Inserting Objects for Multimedia and More

Text is text is text, but Microsoft Word offers much more than simple text management and enhancement techniques. Your Word documents can literally sing, if you choose to add audio clips or voice-overs. They can tell a story, if you choose to add a video segment. Your Web pages can teach, if you want to add a Microsoft PowerPoint presentation to the page you create in Word.

Word makes it easy to both link and embed files (which are called objects for this operation). That means you can work with files you create in other programs, whether they're Microsoft Office applications or not. This chapter gets you up to speed on incorporating objects in your documents, whether you want to add multimedia effects or something more sedate, like a Microsoft Excel spreadsheet or a bit of Microsoft Access data.

What kinds of things might you want to link? You've got all sorts of choices: a sound file, a table, a video clip, an equation, data tables, images, a presentation file, or another Word document.


Create It Once, Use It Again

One of the great things about using a multi-application suite like Office is the way you can reuse what you create. You can open your Excel spreadsheet in your sales report. You can attach an organization chart to the announcement of the new spring promotions. You can add a voice-over segment to a section of a speech you're testing out with your coworkers. You can use these different items in your Word document by importing them as objects.

Although you can copy and paste these items into a document, keeping the data current can be a problem if your information changes often. If you paste a segment of your Excel worksheet in your document, and then the original worksheet changes, your document will be out of date. To resolve this so that you can create these multi-dimensional documents and still keep your documents current, you can link the objects to their original files using object linking and embedding (OLE) and Dynamic Data Exchange (DDE).

NOTE
You can import objects from programs outside the Office applications. As long as the program supports OLE and DDE, you can link and edit that program's objects.


Linking vs. Embedding: A Comparison

Linking and embedding a file might seem like the same process at first. In fact, they are two very different processes, each providing a different function:

  • Linking a file establishes a link between the original (source) file and the file to which you copied the data (destination). Whenever you change the information in the source file, the destination file is updated.
  • Embedding a file places an intact copy of the source in the destination file. Although changing the source doesn't affect the destination file, you can edit the object in the destination file by double-clicking it. You can then edit the object without quitting Word.
TIP
Cut to the Chase

The biggest difference between linking and embedding is the file in which the data is stored (source or destination) and how it's updated (at the source, or originating program, or in the destination document).

Good Candidates for Linking and Embedding

Linking an object is a good choice when you need to keep data in your documents up to date. Here are a few examples:

  • You're creating a draft of a report that includes slides from a PowerPoint presentation that's not yet finished. If the document is linked to the presentation file, when you finish the presentation, the document will reflect the changes.
  • You have a new logo design for your business, and you're trying it out on letterhead. If you maintain the link to the draw file in which the logo is stored, when you change the logo, the letterhead will reflect the changes.
  • You have a sales report due this afternoon, but not all the numbers are in from your regional sales staff. If you import the part of the Excel spreadsheet that's ready and establish a link when you update the information later, the file will reflect the changes.

Embedding objects is a good idea when you don't need to maintain a link but want to edit the object in your document. Here are some examples of embedding:

  • You want to send a snapshot of current Excel data to a coworker, but the information is likely to change.
  • You want to add a finished spreadsheet object. You don't need to maintain the link, but you might want to change the format or values later.
  • You've added an organization chart, but when you send the document to different audiences, you need to change the roles that are displayed.
    NOTE
    Linking an object to a file establishes a one-way link to the source document. When you change the information in the source—for example, when you change the name of a product in the PowerPoint presentation you've imported—the same change is reflected in the document to which you've linked the information.
    TIP
    Link for Small File Size

    When you want to keep your files small, linking is your best bet. Because linked files store only a pointer to the source file, the destination file size increases only a little. Although these types of links introduce other potential problems (such as broken links to deleted or moved source files), they give you the flexibility you might need when size is a consideration.


Linking Objects

Word provides two different ways for you to bring linked objects into your documents. You can use the Insert Object dialog box to place an existing object in your document, and you can use the Paste Special command to use the basic copy-and-paste procedure to establish and maintain a link with the source file.

Inserting a Linked Object

Suppose you have a great new banner ad design that you want to incorporate in the document you're preparing for a client. Although the banner ad isn't quite finished, you want to show the client how the ideas are developing in the presentation. You decide to add the entire presentation to your document as a link in the report.

To insert the object and create a link to the source file, follow these steps:

  1. Place the insertion point where you want to include the object.
  2. Choose Insert, Object. The Object dialog box appears.
  3. Click the Create From File tab (see Figure 15-1). Here you can enter the name for the file you want to insert and choose whether to link or embed the file.
    Figure 15-1. The Object dialog box gives you the means to link or embed objects.
    Figure 15-1. The Object dialog box gives you the means to link or embed objects.
  4. Click Browse. The Browse dialog box is displayed. Navigate to the folder in which the file you want to link is stored, select the file, and click Insert. You are returned to the Object dialog box.
  5. Select the Link To File check box. This tells Word to establish the link to the source.
  6. Click OK. The object is inserted, as Figure 15-2 shows.
    Figure 15-2. The object is placed at the insertion point.
    Figure 15-2. The object is placed at the insertion point.
    TIP
    Run a Presentation

    If your linked object is a PowerPoint presentation, run the presentation by double-clicking it. You won't be able to edit the presentation, however, without opening the source file.

Troubleshooting

The Linked Object Is Missing

So after you go through the steps to insert a linked object, it starts to appear in your file and then—nothing. Just an outline, no object. What's going on?

If you have enabled Picture Placeholders in the Options dialog box, Word is saving memory and screen update time by showing only the outline of the object. You can fix this by choosing Tools, Options and clearing the Picture Placeholders check box on the View tab.

TIP
Create Objects with Create New

The process of embedding uses the Create New tab in the Object dialog box. Embedding an object enables you to include in your document objects you have created in other programs, and it also lets you actually create the objects from scratch while you are working with Word. When you use the items in the Create New tab to create an embedded object, Word launches the program you used to create the object; and then after you save and close the other program, you are returned to Word, and the object is embedded in your current document.

Adding Linked Objects with Paste

Another way to add a linked object in your document is to use Paste Special. This command (available from the Edit menu) copies and pastes not only the data but also a link to the source file. Start in the Word document to which you want to add the linked object, and then follow these steps:

  1. Position the insertion point where you want to add the object.
  2. Launch the program in which you have created the object to be linked. Select the section or object, and copy the item to the Clipboard.
  3. Return to Word, and choose Edit, Paste Special. The Paste Special dialog box appears. (For an example of the Paste Special dialog box, see Figure 15-5.)
  4. Click the Paste Link option, select the object type in the As list box, and click OK. Word adds the data and the link to your document. Note: The Paste Link option is available only for objects you've created in programs that support linking.
    TIP
    When you want to review the links in your current document, choose Edit, Links to display the Links dialog box.

Changing Linked Objects

Any editing you do on a linked object actually takes place in the source file. You can edit a linked object in several different ways:

  • You can double-click the object to launch the source program.
  • You can click the object, choose Edit, Linked Object, and click Edit Link.
  • You can right-click the object to display the shortcut menu. You can then click Linked Object and select Edit Link (see Figure 15-3). This takes you to the source file so that you can make changes as needed.
    Figure 15-3. You can modify a linked object and update the changes.
    Figure 15-3. You can modify a linked object and update the changes.

To modify the source object directly, make your changes in the originating program. Save and close the object as you would normally.

When you return to the linked document, select the linked object and choose Edit, Update Link (or press F9). Depending on how you've set up your options for updates, the destination file might be updated as soon as you return to it or it might be delayed until you manually choose an update.

For more information on controlling the update of linked objects, see the section "Updating Links".

Working with Links

The only tricky part to working with linked objects in your documents is that managing a variety of links can be confusing and a drain on your system's resources. For this reason, Word pulls link management together in one place—the Links dialog box. To display this box, choose Edit, Links (see Figure 15-4).

Figure 15-4. The Links dialog box gives you the means to review, change, update, and remove links to objects you've inserted in your document.
Figure 15-4. The Links dialog box gives you the means to review, change, update, and remove links to objects you've inserted in your document.

Reviewing Links

In the Source File section of the Links dialog box, you see a list of the currently active links in your document. You can scroll through the list to determine the following:

  • The source file for the object
  • The type of object that's linked
  • The type of update assigned to the object

Using the various options in the Links dialog box, you can change the update method of the link, check the source file, modify the location of the source file, and review information about the link. You can also lock the link or break it to protect the destination document from any further changes.

TIP
Update Now

It's possible for you to have some links in the Source File list in the Links dialog box that show Auto updates and others that show Manual updates. You can force the update of a Manual link by selecting it in the Source File list and clicking Update Now.

Updating Links

By default, Word updates any links in your document. Each time you open the file, Word checks whether any links have changed—a process that can take a few minutes if you've added many links to your current document. Similarly, when you make a change to the source file and the destination file happens to be open, Word updates the destination file if you've got the updating options set to update automatically.

Manually Updating Links

Word gives you the option of updating links automatically or manually. Automatic is nice—you don't have to worry about it—unless sharing files is an issue and you want to limit others' ability to change or modify the linked document by editing the source. When you want to set a link in your document to be manually updated, follow these steps:

  1. Choose Edit, Links. The Links dialog box appears.
  2. Select the linked object in the Source File list.
  3. In the Update Method For Selected Link section, click the Manual Update option.
  4. Click OK. The object will be updated only when you choose Update Link from the Edit menu or press F9.

Locking a Link

When you get an object just the way you want it—your PowerPoint presentation is finished, for example, or that logo has finally been approved—you can protect the destination from further changes by locking the link. When you lock a link, it will no longer be updated, even if the source file is modified.

To lock a link, display the Links dialog box, select the linked object in the Source File list, and select the Locked check box in the Update Method For Selected Link section. You can unlock a link later if you choose by repeating the first two steps and clearing the Locked check box.

Troubleshooting

My Changes Are Lost

If Word crashes and then AutoRecover restores your document, you might find that your linked object has lost its most recent changes and is appearing as an outline instead of a fully displayed object. To fix these problems, save the document, click the object, and choose Tools, Options. Clear the Picture Placeholders check box on the View tab, and click OK to close the dialog box. Then, with the object still selected, press F9 to force a manual update. Word compares the object against the source file and updates any missing changes.

Going to the Source

When you want to look at the source file for your document, you can use the Open Source button in the Links dialog box to get to it. Simply select the link in the Source File list and click Open Source. The source program is opened and the file is displayed.

TIP
Edit Your Slide Show

If your source's native application is PowerPoint, Open Source will run a slide show rather than displaying editing mode for the presentation. To launch PowerPoint so that you can make changes in the file, right-click the object in your Word document and choose either Edit Link or Open Link. The PowerPoint work area will be displayed with the first slide shown in Slide view.

Changing the Source

When you want to move a source file, the linked document needs to know a move has taken place. To tell Word the source has moved, choose Edit, Links and, with the link selected, click Change Source in the Links dialog box. The Change Source dialog box appears. Navigate to the folder where the source file is now located, click the file, and click Open. Click OK to close the Links dialog box.

Breaking Links

After you have a file in its finished state, you might want to break a link to keep the object from future modifications. To break the link of a selected object, follow these steps:

  1. Display the Links dialog box by choosing Edit, Links.
  2. In the Source File list, select the link you want to break.
  3. Click Break Link. Word displays a message box asking you to confirm that you want to proceed with the operation.
  4. Click Yes to break the link. The link is removed from the list, although the object remains in your document. Any further changes to the source file will not affect your document.
  5. Click Close to close the Links dialog box.
    NOTE
    If you want to re-establish the link you just broke, you can press Ctrl+Z or select Undo to re-establish the link.

Linking Considerations for Shared Files

As you can see, managing the links for your documents could be a fairly complicated process, especially if you create a number of links to each document and choose to have some updated automatically and others updated manually. Reviewing your links regularly, as well as keeping a list of active links for current files, is a way to ensure that an important source file doesn't disappear 15 minutes before a major meeting.

If your document is linked to a source file on a network server, you run the risk that the document might be changed, moved, or deleted by another user. Although Word looks for the missing file, there's no guarantee it will find it. Make sure that you keep active backups of important files and that you review your links often.

Another network consideration: If your source file is stored in a shared directory, it's possible that another user can access your file and make a change without your knowledge. This is fine if the change makes things better, but what if the change introduces an error you miss? To control the access to the file, you can choose to manually update the link when you add the linked object.

Troubleshooting

The Source File Has Moved

If you get an error when you try to edit a linked or embedded object, check to see whether the source file has been moved. To do this, click the linked object, choose Edit, Links. Use the Change Source button in the Links dialog box to reconnect the links.


Embedding Objects

Embedding objects, by contrast to linking objects, is a pretty straightforward process. There are no links to worry about or maintain. You simply place an object in the document and there it stays. Pretty clean and simple.

The downside of embedded objects is the size of the file they create. When you add a PowerPoint presentation to your destination document, for example, your Word file takes on the weight of the additional file. With a linked file, only the link to the source file is actually stored in the document.

You also have an additional choice with embedded objects that you didn't have with linked objects: You can create a new embedded object on the fly. That is, you can create a new object while you're working in your Word document. This section explores ways to embed data sections, create new embedded objects, edit your objects, and convert them to other file formats.

Pasting Data as an Embedded Object

When you want to embed a portion of a file, you can use Paste Special to import the information, keeping the formatting intact. Here are the steps for embedding a section of data:

  1. In the source program, open the data file from which you want to copy data.
  2. Select the data, and copy it to the Clipboard.
  3. Open your destination document, and place the insertion point where you want to add the data.
  4. Choose Edit, Paste Special. The Paste Special dialog box appears, as Figure 15-5 shows.
    Figure 15-5. The Paste Special dialog box enables you to both link and embed data.
    Figure 15-5. The Paste Special dialog box enables you to both link and embed data.

Creating an Embedded Object

What kind of object would you like to add as you're working on your Word document? Word enables you to create embedded objects as you work in Word, using programs such as Microsoft Equation 3.0, PowerPoint, Paintbrush, and RealNetworks' RealPlayer. You also can add data from Excel, a slide from PowerPoint, a wave (sound) file from Microsoft Sound Recorder, a video segment from Media Clip, or any number of other programs you might have installed on your system.

To create an embedded object in Word, follow these steps:

  1. Start in the document to which you want to add the embedded object.
  2. Place the insertion point where you want to add the object.
  3. Choose Insert, Object. The Insert Object dialog box appears, with the Create New tab selected, as Figure 15-6 shows.
    Figure 15-6. You can create an embedded object from within your Word document.
    Figure 15-6. You can create an embedded object from within your Word document.
  4. Scroll through the Object Type list, and select the one you want.
  5. If you want to have the embedded object displayed as an icon instead of a file, select the Display As Icon check box.
  6. Click OK to close the dialog box and launch the program. Figure 15-7 shows the screen that appears when Microsoft PowerPoint Slide is selected.
    NOTE
    Depending on the program you're using to create the embedded object, the menus you see might differ from those you see here. Different programs offer different levels of support for object linking and embedding. If you need help with the program you're using to create the embedded object, consult that program's help system or your program documentation.
  7. In the source program, choose File and select the command that enables you to close the program and return to Word. The program is closed, and you are returned to the destination document. If you chose to display the object as an icon, the icon is displayed at the insertion point. If you chose to clear the Display As Icon check box, the file is displayed in full.
    TIP
    Change the Icon

    If you elect to display the embedded object as an icon, a Change Icon button appears in the Insert Object dialog box that changes the icon used in your document. To see the list of displayed icons, click the Change Icon button, and scroll through the list to see the available icons. Click Browse if necessary, and select the file you want. Click in the Caption box, add a caption and click OK to accept the change.

    Figure 15-7. Creating an embedded object in Word involves working in the source program.
    Figure 15-7. Creating an embedded object in Word involves working in the source program.

Adding an Existing Object

Adding a file or data section to your document as an embedded object allows you to keep all the data in one place, which makes your file portable. The benefit of embedding a file as opposed to copying it in your document is that you can edit an embedded object—in its originating program—from within your Word document.

To add an existing object to your Word document, follow these steps:

  1. Place the insertion point where you want to add the embedded object.
  2. Choose Insert, Object.
  3. Click the Create From File tab (see Figure 15-8). Click Browse, select the file you want to embed, and click Insert.
  4. If you want the embedded object to appear as an icon, select the Display As Icon check box.
  5. Click OK to add the object.
    NOTE
    The process for embedding an object is only one step removed from adding a linked object: In the Create From file tab, you don't select the Link To File check box. By leaving this check box unselected, you tell Word that the file is to be incorporated as an embedded object in the current document.
    Figure 15-8. Use the Create From File tab in the Insert Object dialog box to embed an existing file.
    Figure 15-8. Use the Create From File tab in the Insert Object dialog box to embed an existing file.

Editing an Embedded Object

You edit an embedded object by double-clicking it—whether the object is a section of a file or an entire embedded file. Double-clicking opens the program in which the file was created. You can make your changes as needed and choose File, Close And Return To Microsoft Word to accept the changes in your document.

Troubleshooting

I Can't Edit an Embedded Object

You double-click an object to edit it, and nothing happens. What's going on? These are the possibilities:

  • Make sure the source program is still installed. If it's not, install it or convert the embedded object to a file format you can use.
  • Make sure that you're not running low on system memory. If that appears to be the problem, close all other programs to free up space.
  • If you're working with a linked object on a network, make sure that no one else has the source file open at the same time.
  • Make sure that the source file hasn't been moved or renamed. Check this by clicking the object and choosing Edit, Links.

Converting Embedded Objects to Other Formats

Your embedded file has all the data it needs in order to be complete. But what happens when you copy the file to a disk and take it to another computer that doesn't have the source file? You could install the source program—if you have it handy. If not, another option is to convert the embedded object to a file format you can use.

To convert an embedded object, follow these steps:

  1. Right-click the embedded object.
  2. On the shortcut menu, choose Object, Convert. The Convert dialog box appears, as Figure 15-9 shows.
    Figure 15-9. Converting an embedded object enables you to save it in another file format.
    Figure 15-9. Converting an embedded object enables you to save it in another file format.
  3. Choose the file format to which you want to convert the embedded file, and click OK. The file is converted as you selected.
    NOTE
    Use Activate As if you want to open an object as the type you select in the Object dialog box and then allow it to return to its natural object type when you close it.


Debugging Macros and Custom Functions

If you have made it through the last three chapters, you now have at least a smattering of Microsoft Visual Basic for Applications (VBA) at your command—as well as, we hope, an appetite for learning more. The best ways to acquire more expertise in this versatile programming language are to read a text on the subject (such as Microsoft Excel 2000/Visual Basic for Applications Fundamentals, from Microsoft Press) and to experiment. As you do your everyday work in Microsoft Excel, look for chores that are ripe for automating. When you come across something macro-worthy, record your actions. Then inspect the code generated by the macro recorder. Make sure you understand what the recorder has given you (read the Help text for any statements you don't understand), and see whether you can find ways to make the code more efficient. Eliminate statements that appear unnecessary, and then see whether the code still does what you expect it to do. Look for statements that select ranges or other objects, and see whether you can make your code perform the essential tasks without first selecting those objects.

As you experiment, and as you create larger and more complex macros and functions, you will undoubtedly produce some code that either doesn't run at all or doesn't give you the result you're looking for. Missteps of this kind are an inevitable part of the learning process. (They're also an inherent part of programming, even for experts.) Fortunately, the VBA language and the Visual Basic Editor (VBE) provide tools to help you trap errors and root out bugs. Those tools are the subject of this chapter.

In this chapter, you look at two kinds of error-catching tools: those that help you at design time, when you're creating or editing code, and those that work at run time, while the code is running.


Using Design-Time Tools

The VBE's design-time error tools let you correct mistakes in VBA syntax and catch misspellings of variable names. They also let you follow the "flow" of a macro or function (seeing each line of code as it is executed) and monitor the values of variables during the course of a procedure's execution.

Catching Syntax Errors

If you enter a worksheet formula incorrectly in Excel, Excel alerts you to the error and refuses to accept the entry. The VBA compiler (the system component that converts your English-like VBA code into machine language) normally performs the same service for you if you enter a VBA expression incorrectly. If you omit a required parenthesis, for example, the compiler beeps as soon as you press Enter. It also presents an error message and displays the offending line of code in a contrasting color (red, by default).

Certain kinds of syntax errors don't become apparent to the compiler until you attempt to run your code. For example, if you write the following:

With Selection.Border

        .Weight = xlThin

        .LineStyle = xlAutomatic

and attempt to run this code without including an End With statement, you will see this error message.

Your procedure will halt, and you will be in break mode. (You can tell you're in break mode by the appearance of the word break, in brackets, in the VBE title bar. The line that the compiler was attempting to execute will be highlighted—by default, in yellow.) Break mode lets you fix your code and then continue running it. For example, if you omit an End With statement, you can add that statement while in break mode, and then press F5 (or choose Run, Continue) to go on with the show. If you want to exit from break mode, rather than continue with the execution of your procedure, choose Run, Reset.

If you don't like having the compiler complain about obvious syntax errors the moment you commit them, you can turn that functionality off. Choose Tools, Options, click the Editor tab (shown in Figure 34-1), and clear the Auto Syntax Check check box. With automatic syntax checking turned off, your syntax errors will still be flagged when you try to run your code.

Figure 34-1. Clear Auto Syntax Check if you don't want to know about syntax errors until you run your code.
Figure 34-1. Clear Auto Syntax Check if you don't want to know about syntax errors until you run your code.
TIP
Change color with the Options dialog box

You can also use the Options dialog box to change the color that the VBE uses to highlight syntax errors. If you don't like red, click the Editor Format tab, select Syntax Error Text in the code Colors list, and choose a different color.

Auto Syntax Check is on by default. So are three other "auto" options—Auto List Members, Auto Quick Info, and Auto Data Tips. These are all useful, and you should leave them on, especially if you're a relative newcomer to VBA. Auto List Members and Auto Quick Info help you complete a line of VBA code by displaying options available at the current insertion point or the names of arguments required by the function you're currently entering. Auto Data Tips is relevant only in break mode. If you hover your mouse cursor over a variable name in break mode, the Auto Data Tips feature displays the current value of that variable as a ScreenTip.

Catching Misspelled Variable Names

The VBA compiler doesn't care about the capitalization style of your variable names. MyVar, myVar, and myvar are identical names as far as the compiler is concerned. (If you're inconsistent about the capitalization of a variable name, the VBE adjusts all instances of that variable to make them look the same.) If you change the spelling of a variable name in mid-program, however, the compiler creates a new variable—and havoc for your program. An error in programming introduced by a misspelled variable can be especially treacherous because the program might appear to behave normally.

You can virtually eliminate the possibility of inconsistently spelled variable names in a module by adding a single statement at the top of that module (above any Sub or Function statements):

Option Explicit

The Option Explicit statement forces you to declare any variables used in the current module. You declare variables with Dim statements. (For the complete details about Dim, type Dim in a module and press F1.) With Option Explicit in place, if you use a variable without first declaring it, you get a Compile Error at run time. If you accidentally misspell a variable name somewhere in your program, the misspelled variable will be flagged by the compiler as an undeclared variable, and you'll be able to fix the problem forthwith.

You can add Option Explicit to every new module you create by choosing Tools, Options, clicking the Editor tab, and selecting Require Variable Declaration. This option is off by default, but it's good programming practice to turn it on. Option Explicit will do more for you than eliminate misspelled variable names. By forcing you to declare your variables, it will also encourage you to think ahead as you work.

Stepping Through Code

The VBE's step commands cause the compiler to execute either a single instruction or a limited set of instructions and then pause in break mode, highlighting the next instruction that will be executed. Execution is suspended until you take another action—such as issuing another step command, resuming normal execution, or terminating execution. By issuing step commands repeatedly, you can follow the procedure's execution path. You can see, for example, which way the program branches when it comes to an If statement, or which of the alternative paths it takes when it encounters a Select Case structure. (A Select Case structure causes the program to execute one of a set of alternative statements, depending on the value of a particular variable. For details, type case in a module and press F1.) You can also examine the values of variables at each step along the way.

TIP
Monitor variable value

You can monitor the value of variables by displaying the Watch window or the Quick Watch dialog box, or by hovering your mouse cursor over particular variables while in break mode. For information about using the Watch window, see "Using the Watch Window to Monitor Variable Values and Object Properties."

You have four step commands at your disposal. You'll find these commands—and their keyboard shortcuts—on the Debug menu:

  • Step Into executes the next instruction only.
  • Step Over works like Step Into unless the next instruction is a call to another procedure. In that case, Step Into executes the entire called procedure as a unit.
  • Step Out executes the remaining steps of the current procedure.
  • Run To Cursor executes everything up to the current cursor position.

You can run an entire procedure one step at a time by pressing F8 (the keyboard shortcut for Debug, Step Into) repeatedly. To begin stepping through a procedure at a particular instruction, move your cursor to that instruction and press Ctrl+F8 (the shortcut for Debug, Run To Cursor). Alternatively, you can force the compiler to enter break mode when it reaches a particular instruction, and then use any of the step commands.

Setting Breakpoints with the Toggle Breakpoint Command

A breakpoint is an instruction that causes the compiler to halt execution and enter break mode. The simplest way to set a breakpoint is to put your cursor where you want the breakpoint and choose Debug, Toggle Breakpoint (or press F9). Choose this command a second time to clear a breakpoint. You can set as many breakpoints in a procedure as you like using this method. The Toggle Breakpoint command sets an unconditional breakpoint—one that will always occur when execution arrives at the breakpoint. To set a conditional breakpoint—one that takes effect only under a specified condition—see the next section.

As Figure 34-2, the VBE highlights a line where you've set a breakpoint in a contrasting color and displays a large bullet in the left margin of the Code window. To customize the highlighting color, choose Tools, Options, click the Editor Format tab, and select Breakpoint Text.

Figure 34-2. The VBE uses highlighting to mark breakpoint lines.
Figure 34-2. The VBE uses highlighting to mark breakpoint lines.

Setting Conditional Breakpoints Using Debug.Assert

With the Assert method of the Debug object, you can cause the VBA compiler to enter break mode only if a particular expression generates a FALSE result. Figure 34-3 provides a simple example.

Figure 34-3. This Debug.Assert statement puts the compiler in break mode when the value of x becomes 9 or greater.
Figure 34-3. This Debug.Assert statement puts the compiler in break mode when the value of x becomes 9 or greater.

The Debug.Assert statement in this otherwise useless bit of code asserts that x is less than 9. As long as that assertion is true, the procedure runs. When it becomes false, the compiler enters break mode. As the Watch window in Figure 34-3 shows, the compiler enters break mode when x is equal to 9. (The Watch window is discussed next.)

You can also use the Watch window to set conditional breakpoints. See "Setting Conditional Breakpoints with the Watch Window."

Using the Watch Window to Monitor Variable Values and Object Properties

The Watch window shows the current values of selected variables or expressions and the current property settings for selected objects. You can use the Watch window to monitor the status of variables and objects as you step through a procedure.

In Figure 34-3, the Watch window shows a single variable, x. Figure 34-4 shows a Watch window monitoring eight variables. The first four of these are object variables—variables set to various worksheet ranges. Because objects have properties, the Watch window displays outline controls beside the names of these variables. Opening an outline control reveals an object's property settings, as Figure 34-5 shows.

Figure 34-4. You can monitor the status of variables and objects in the Watch window.
Figure 34-4. You can monitor the status of variables and objects in the Watch window.
Figure 34-5. Opening an outline control associated with an object or object variable reveals that object's properties.
Figure 34-5. Opening an outline control associated with an object or object variable reveals that object's properties.

To display the Watch window, choose View, Watch Window. (To close the window, click its Close button.) To add a variable or object to the Watch window, you can select it in the Code window and drag it into the Watch window. You can add expressions, such as a + 1, to the Watch window in this manner. Alternatively, you can add something to the Watch window by choosing Debug, Add Watch. In the Expression box of the Add Watch dialog box (see Figure 34-6), type a variable name or other valid VBA expression.

Figure 34-6. You can use the Add Watch dialog box to add a watch variable or set a conditional breakpoint.
Figure 34-6. You can use the Add Watch dialog box to add a watch variable or set a conditional breakpoint.

Setting Conditional Breakpoints with the Watch Window

As Figure 34-6 shows, you can use the Add Watch dialog box to set a conditional breakpoint. Choose Debug, Add Watch, specify the name of a variable or a VBA expression, and then select either Break When Value Is True or Break When Value Changes. Selecting Break When Value Is True for an expression is comparable to using a Debug.Assert statement to set a conditional breakpoint. The difference is that Debug.Assert causes a break when an expression becomes false, and the Break When Value Is True option does the opposite.

Using Quick Watch to Monitor a Variable or Add a Watch Item

In break mode you can select any variable name or expression in your code and choose Debug, Quick Watch (or press Shift + F9) to see the current value of the selected item. If you decide you want to monitor that item continuously, you can click Add in the Quick Watch dialog box. The VBE then adds the item to the Watch window.

Using the Immediate Window

While in break mode, or before running a procedure, you can execute any VBA statement in the Immediate window. (If the Immediate window isn't visible, choose View, Immediate Window or press Ctrl+G.) For example, you can find out the value of a variable x by typing Print x in the Immediate window. (As a shortcut, you can type ?x. The question-mark character is a synonym for Print in VBA.)

You can also use the Immediate window to monitor action in a procedure while that procedure is running. You do this by inserting Debug.Print statements into the procedure. The statement Debug.Print x, for example, displays the current value of x in the Immediate window.

The Immediate window can be a handy place to test VBA statements while you're still wrestling with the syntax of this programming language. If you're not sure that a particular statement will have the effect that you intend, you can try it out in the Immediate window and see what happens.


Dealing with Run-Time Errors

In many cases, run-time errors are caused by factors outside your control. For example, suppose you have written the following macro to format the numbers in a selected range using the Indian system of lakhs and crores:

Sub LakhsCrores()
    For Each cell In Selection
        If Abs(cell.Value) > 10000000 Then
            cell.NumberFormat = "#"",""##"",""##"",""###"
        ElseIf Abs(cell.Value) > 100000 Then
            cell.NumberFormat = "##"",""##"",""###"
        End If
    Next cell
End Sub

This macro works fine if the person who runs it selects a range containing numbers before running the macro. But if the user selects something else—a chart, for example—VBA displays the error message shown here.

The macro generates run-time error 438 and enters break mode because the For Each statement has to be applied to a collection or an array, and a chart object is neither (a range is a collection of cells, so For Each does work with a range). Even though you can figure out easily enough what the error message means and what you have to do about it (try again with a range selected), the message might still be annoying. If you intend for this macro to be used by someone else, it's definitely impolite to let that other user see such a message.

You can "trap" an error like this—that is, shield yourself and others from VBA's run-time error messages—by means of an On Error Goto statement. The statement must appear before the code that might cause a run-time error, and it has the following syntax, where label is a name that identifies an error-handling section elsewhere in your program.

On Error Goto label

If a run-time error occurs, the On Error Goto statement transfers execution to the error-handling code. In the case of your LakhsCrores routine, the macro complete with error handling might look like this:

Sub LakhsCrores()
    `Catch run-time error caused by inappropriate selection
    On Error GoTo Errorhandler

    For Each cell In Selection
        If Abs(cell.Value) > 10000000 Then
            cell.NumberFormat = "#"",""##"",""##"",""###"
        ElseIf Abs(cell.Value) > 100000 Then
            cell.NumberFormat = "##"",""##"",""###"
        End If
    Next cell

    `Exit sub statement keeps execution from entering
 `error handler if no error occurs
        Exit Sub

`Error handler
Errorhandler:
    MsgBox "Please select a worksheet range"
End Sub

Notice that the error handler goes at the end of the program, introduced by the label that appeared in the On Error statement. The label must be followed by a colon and must appear on a line by itself. An Exit Sub statement appears before the error handler. This statement terminates the macro when no run-time error occurs; without it, execution would "fall into" the error handler regardless of whether an error occurred. Now when the user runs the macro after selecting a chart object, the user sees a polite message box instead of a rude VBA run-time error message.

The macro still has a problem, however. The code works fine when the selected work-sheet range includes numbers, text, or blank cells. If it includes a cell containing an Excel error constant, such as #NA, however, a different run-time error occurs—error number 13, Type Mismatch. The message box generated by the error handler shown previously would not be appropriate for this kind of error.

How do you make your code show one message for a non-range selection and another for a range that includes one or more error values? You use the Number property of the Err object. This property is always set to the most recent run-time error number (or 0, if no procedure is running or if no error has occurred). You could handle both run-time errors (438 and 13) with the following code:

ErrorHandler:
     If Err.Number=438 Then
        MsgBox "Please select a worksheet range"
     Else
          MsgBox "Please select a range without error values"
     End If

In case the code is susceptible to some other run-time error that you haven't anticipated, you might want to make the handler look like this:

ErrorHandler:
     If Err.Number = 438 Then
        MsgBox "Please select a worksheet range"
     ElseIf Err.Number = 13 Then
          MsgBox "Please select a range without error values"
     Else
          MsgBox "Sorry! Unknown error!"
     End If

This isn't particularly elegant, but at least you've got all the bases more-or-less covered.

The foregoing error-handler examples assume that your program should terminate when a run-time error occurs. The purpose of the error handler is to prevent the jolting VBA message from showing up—and to provide the user with a simple explanation of what has gone wrong.

In some cases you'll want your procedure to continue running after a run-time error occurs. In such a case, your error handler needs to return VBA to the appropriate instruction so that it can continue executing your program. Use either a Resume or Resume Next statement to do this. A Resume statement causes VBA to re-execute the line that caused the error. A Resume Next statement causes VBA to continue at the line that follows the line that caused the error.

By combining On Error with Resume Next, you can tell VBA to ignore any run-time error that might occur and go to the next statement. If you're sure you've anticipated all the kinds of run-time errors that might occur with your program, On Error Resume Next can often be the simplest and most effective way to deal with potential mishaps. In the LakhsCrores macro, for example, you can write the following:

Sub LakhsCrores()
    `Tell VBA to ignore all run-time errors
    On Error Resume Next

    For Each cell In Selection
        If Abs(cell.Value) > 10000000 Then
            cell.NumberFormat = "#"",""##"",""##"",""###"
        ElseIf Abs(cell.Value) > 100000 Then
            cell.NumberFormat = "##"",""##"",""###"
        End If
    Next cell
  Exit Sub

With this code, if the user selects a chart and runs the macro, the run-time error is ignored, the program moves on to the For Each block, and nothing happens—because nothing can happen. If the user selects a range containing one or more error values, the program skips over those cells that it can't format and formats the ones it can. In all cases, neither error message nor message box appears, and all is well. This solution is ideal for this particular macro.

Of course, when you use On Error Resume Next, you're disabling VBA's run-time checking altogether. You should do this only when you're sure you've thought of everything that could possibly go awry—and the best way to arrive at that serene certainty is to test, test, and then test some more.


ch35.html

Chapter 35

Using SharePoint Team Web Sites

If you install SharePoint Team Services on your Web server, workgroups throughout your organization can use SharePoint team Web sites to coordinate their work. Team Web sites help people work together by providing an easy-to-use repository of project documents, discussions, and lists of virtually anything the project needs to record.

Lists are central to the operation of a SharePoint team Web site. Physically, a list is just a database table. But the power of lists comes from the fact that you can create them, update them, display them, and if necessary delete them using standard Web pages that team members can quickly learn to use.

SharePoint team Web sites provide the following services to anyone with a Web browser, connectivity to your server, and the necessary permissions:

  • Document Libraries. A SharePoint team Web site document library has two components: a folder full of documents and a list that describes them. You can search for documents using either the document content itself or the data in the list:
    • Web Discussions. After an Office 2000 or Office XP user saves a document to a Web server as HTML (and recall: this is an integrated, one-step process), Web visitors browsing that document can make comments using a discussion toolbar. SharePoint Team Services stores these comments separately from the document itself. Then, when the document creator opens the document, all the comments appear seamlessly merged.
    • Search page. This feature uses Microsoft Indexing Service to search for documents within the current SharePoint team Web site.

      • The clients for these features are either a browser (for the Web-based tasks) or standard Office applications (for document creation and retrieval).

  • Discussion Boards. This is the sort of feature most people call a threaded discussion group. Within a team Web site, you can create as many Discussion Boards as you like, and each board can accommodate an almost unlimited number of threads and messages. You can sort and present the messages any way you like, and purge old messages automatically.
  • Lists. These are the basic unit of storage in a SharePoint team Web site. They can contain a list of announcements, a list of upcoming events, a list of scheduled tasks, a list of team members or contacts, a list of excuses, or anything else you like. The number of lists and the fields they contain are totally at your discretion.
  • Subscriptions. With this feature, team members can ask to be notified whenever a specified document or folder changes. SharePoint Team Services detects such changes and sends the notifications by e-mail.
  • Administration. This Web-based tool provides control over the preceding applications.


Creating a New SharePoint Team Web Site

SharePoint Team Services runs on Microsoft Windows 2000 computers with Microsoft Internet Information Services (IIS) 5.0 installed. SharePoint Team Services is a server-based application, so installing it requires Administrator privileges on the target machine. At a high level, here are the tasks required:

  1. Install Windows 2000 Professional, Windows 2000 Server, or any later version.
    2. NOTE
    Although Windows 2000 Professional will run SharePoint Team Services, Microsoft intends this as a development platform. Windows 2000 Professional isn't licensed for use as a widely accessible Web server.
  2. Install IIS.

    3. For more information about installing IIS, refer to Chapter 37, "Installing and Configuring a Web Server."

  3. Install SharePoint Team Services by running \sharept\setupse.exe from your Office XP CD, or by downloading it from Microsoft's Web site at http://www.microsoft.com/servers and following the accompanying instructions.

As always, it's generally best to upgrade Windows 2000 and IIS to the latest release or service pack, and to install the most up-to-date release of SharePoint Team Services. For information about using SharePoint Team Services on other operating systems, monitor Microsoft's Web site.

Installing SharePoint Team Services installs the following items:

  • SharePoint team Web site application components. These include Web pages, ASP pages, ActiveX controls, and so forth.
  • Microsoft FrontPage Server Extensions 2002. If the Web server already contains an earlier version of the extensions, installing SharePoint Team Services will upgrade them.
  • Microsoft Data Engine (MSDE). This is essentially a version of Microsoft SQL Server, but it lacks the tools you need to design and manage your own databases. If you already have a copy of SQL Server running on your network, SharePoint Team Services can use that installation rather than MSDE.

Installing SharePoint Team Services also installs a team Web site in the Web server's root folder. If the server already contains a home page, the setup program will prompt you before replacing it with the team Web site's home page. If you choose not to replace the existing home page, Setup saves the team Web site's home page using a different name.

If your computer has only one virtual Web server, installing SharePoint Team Services adds the FrontPage Server Extensions and other SharePoint Team Services features to that server automatically. Otherwise, SharePoint Team Services Setup asks you which servers to extend. After you install SharePoint Team Services, you can install it on or remove it at will from any virtual server on the same system.

For more information about installing and removing the FrontPage Server extensions on individual virtual servers, refer to Chapter 38, "Understanding the FrontPage Server Extensions."

Microsoft designed SharePoint team Web sites for use by as many as 500 to 600 people who work together as a group (such as a department or project). The optimal number of users is smaller. If you have a lot of people, you probably have a lot of departments or projects, and you should generally create a separate team Web site for each one. Fortunately, a single Web server can host any number of SharePoint team Web sites.

For more information about creating SharePoint team Web sites, refer to "Creating a SharePoint Team Web Site."

Figure 35-1 illustrates the home page for a typical SharePoint team Web site located in the Web server's root folder. Additional team Web sites on the same server would, of course, have folder paths in their URLs:

  • The menu bar at the top of the page provides access to all features in the site.
  • The Quick Launch area at the left provides hyperlinks to whatever high-usage features you select.
  • The Search Documents text box and accompanying Go button search all documents libraries for a given string of text.
  • The Announcements and Events areas provide links to the Announcements and Events lists and display recent additions to those lists.
  • The Links area provides hyperlinks that team members might frequently use. This data resides in a list called, logically enough, Links.
    • Figure 35-1. The home page for a SharePoint team Web site is highly configurable, but this version is fairly typical for a new site.
    Figure 35-1. The home page for a SharePoint team Web site is highly configurable, but this version is fairly typical for a new site.

In general, it's best to block anonymous access to SharePoint team Web sites. Otherwise, the Web server won't prompt team members for usernames and passwords, and none of the data in the team Web site will be identified by team member.

For more information about controlling access to team Web sites, refer to "Administering SharePoint Team Web Site Settings" later in this chapter.


Using Document Libraries

Click Documents on the SharePoint team Web site menu bar to display the Document Libraries page shown in Figure 35-2. This page displays an icon representing each document library in the current team Web site. The one library shown in the figure—Shared Documents—appears automatically in every new team Web site, but you can create as many document libraries as you want. The New Document Library link jumps to a New page that creates new libraries, as do various other links located conveniently throughout the team Web site.

Figure 35-2. This page provides a selection list of SharePoint team Web site document libraries. The one library shown here appears by default in every new team Web site.
Figure 35-2. This page provides a selection list of SharePoint team Web site document libraries. The one library shown here appears by default in every new team Web site.

How Document Libraries Work

SharePoint team Web site document libraries have three major components:

  • A folder named Shared Documents, where all the documents reside.
  • A database table—stored in MSDE—that records additional information about each document in the library.
  • A series of Web pages that update the document library, perform queries against it, and so forth.

Adding a document to the library requires updating two of these components in unison: the Shared Documents folder and the database table. That's why you should always update team Web site document libraries through the Web pages provided, or directly from Office XP using Web Folders (or, on Windows 2000, an HTTP location in My Network Places).

Click the icon for any library, or click the Shared Documents link, to display a Document Library View page like the one in Figure 35-3. This page lists the documents in the library.

Figure 35-3. Click a library name or icon in a Document Libraries page (Figure 35-2), or click the Shared Documents link, to display a list of documents like this.
Figure 35-3. Click a library name or icon in a Document Libraries page (Figure 35-2), or click the Shared Documents link, to display a list of documents like this.

Here are its notable features:

  • Main Document Area. This is the large area with a white background that appears in the center of the Web page. It lists all the documents in the current library. To sort this listing on any field, click the field's column heading. (That is, click File Name, Last Modified, or Modified By.)
  • Select A View. This area in the top left corner selects among all available formats for listing documents in the library. By default, there are two such formats:
    • All Documents. Displays one line of text for each document in the library. Figure 35-3 illustrates this format.
    • Folder View. Displays one icon for each file or folder in the library. The icons appear from left to right across the available display area, then wrap to the next line.

    To create additional views, click the Modify Settings And Columns link to display a Customization page, and then click the Create A New View link at the bottom of the page.

  • Search Documents. This area appears just below the Select A View area. To locate documents that contain a given word or phrase. Enter the text in the box provided, and click Go.
  • New Document. Click this link to begin editing a new document you plan to store in the current library. If the library specifies a template, the Web page downloads it, starts the appropriate editor, and specifies the current library as the default save location. If the library has no defined template, the Web page starts Microsoft Word.
    • TIP
    When saving documents into a SharePoint team Web site library (or saving them to disk in preparation for upload to a team Web site library), it's usually best to save them in HTML format. That way, other team members can view and annotate the document directly in their browsers. If you save or upload a non-HTML document in its native format, other team members will have to download the document, open it with another program, and then upload it again if they've made any changes.
  • Upload Document. Click this link to display an Upload Document page that uploads a document from your computer and adds it to the library.
  • Filter. Click this link to limit the list of documents based on criteria you specify. The team Web site redisplays the current Web pages, adding selection controls above each selectable column heading.
  • Subscribe. Click this link to display a New Subscription page. This page tells SharePoint Team Services to send you an e-mail message whenever someone changes the contents of a document or folder within the library.
    • NOTE
    Subscription is a pervasive feature. You can subscribe to receive change notifications regarding almost any aspect of a team Web site.
  • Modify Settings And Columns. Click this link to display a Customization page that modifies the name of library, its assigned template, its presence or absence on the quick launch bar, and so forth.

    • Significantly, clicking this link also provides options that add or remove columns (that is, fields) from the document listing. You can use these extra columns to record anything you want about the documents in the library, and then to sort or filter documents on that basis. For example, you could add fields to record the:

    • Name of the product that the document describes.
    • Product version.
    • Document version.
    • Contract or customer for whom you created the document.

Troubleshooting

Team Web Site document search displays message, "Service is not running"

When using a Team Web Site, entering a search phrase in a Search Documents box and clicking Go might result in the following message:

Service is not running.

This message appears if Microsoft Indexing Service isn't running on the Web server where the Team Web Site resides. To start this service:

  1. Choose Programs from the Windows Start menu.
  2. Choose Computer Management from the Administrative Tools menu.
  3. By default, the Computer Management application manages the local computer. To control Indexing Service on a different computer, right-click Computer Management (Local), choose Connect To Another Computer, select the name of the server where the Team Web Site resides, and click OK.
  4. Expand the Services And Applications entry.
  5. Right-click the Indexing Service entry, and then choose Start from the shortcut menu. Click Yes when prompted to start Indexing Service. (If no Indexing Service entry appears, Microsoft Indexing Service isn't installed on the computer. The topic "Installing IIS on Windows 2000" in Chapter 37 explains how to install Indexing Service.)
  6. Click the Indexing Service entry once, and observe the display in the right pane of the Computer Management window. This display contains one line for each Indexing Service catalog. Here are your options:
    • If none of the catalogs include your Web server's root folder, right-click Indexing Service, choose New from the shortcut menu, and then choose Catalog. In the Name field, give the catalog a name that relates it to your Web server. In the Location field, specify the physical location of your Web server's root folder. Finally, click OK.
    • If a suitable catalog already exists, observe the Total Docs and Docs To Index columns in the Computer Management window's right pane. When Total Docs is not zero and Docs to Index is zero, Indexing Service has finished analyzing your Web server.
  7. Try rerunning the Team Web Site search. If you still get the same error message, try stopping and restarting IIS. If the search still fails, try rebooting the server.

Each line in the main document area of a Document Library View page (Figure 35-3) contains the following clickable areas:

  • File Name. Click any file name (or its icon) to open the file for viewing. If the file is a type that the browser can display, the browser displays it. Otherwise, the browser treats it as a download and starts the application on your computer that's associated with the file type.
  • Edit. Click this icon to display an Edit Item page that updates the corresponding file or any information that describes it.
  • Modified By. Click any name in this column to display a Personal Settings page that displays information about that team member.

Click any Edit icon in the Document Library View page to display the Edit Item Form page shown in Figure 35-4.

Figure 35-4. This SharePoint team Web site page displays a list of document properties you can edit.
Figure 35-4. This SharePoint team Web site page displays a list of document properties you can edit.

This form provides the following capabilities:

  • Save And Close. Click this link to save any changes you've made and return to the document library listing.
  • Delete. Click this link to delete the current document from the library.
  • Send For Review. Click this link to send e-mail to anyone you specify, asking that person to review the current library document.
  • Discuss. Click this link to open the current document for review and annotation.
  • Edit In <application>. Click this link to start the application associated with the current document and tell it to load the document from the Web server.
  • Go Back To Document Library. Click this link to abandon any changes you've made and return to the document library listing.
  • Document Information Fields. The central portion of the form contains form elements for all the editable fields that describe the document. To change any of this data, update the corresponding field and then click Save And Close.

With two exceptions, these options are relatively straightforward. The exceptions involve the options Discuss and Send For Review (which uses Discuss).

Using Web Discussions

The Discuss option is what most Office applications call Web Discussions. Despite the similarity in names, it has nothing to do with SharePoint team Web site Discussion Groups. Web Discussions provide a way to add yellow "sticky notes" to a document and to share those notes with others—all without actually updating the document itself. This is possible because the "sticky note" information resides in a database on a so-called discussion server. This can be any SQL Server or MSDE database that services a team Web site.

This is a very useful approach, because several people can review and annotate the same document simultaneously, and then the document owner can see all their suggestions merged together. There are no concerns about someone accidentally updating the document itself, because no one can update the document at all.

One of three things can happen when you click the Discuss link on the Edit Item Form page:

  • If Microsoft Internet Explorer isn't configured to use a discussion server, it displays the dialog box shown in Figure 35-5 asking whether you'd like to specify one.
    • Figure 35-5. Discussing a document requires access to a discussion server that stores any comments you make. If Internet Explorer doesn't know the name of the discussion server, it displays this prompt.
    Figure 35-5. Discussing a document requires access to a discussion server that stores any comments you make. If Internet Explorer doesn't know the name of the discussion server, it displays this prompt.
  • If the document is in HTML format, reviewers can view the document and add their sticky notes using nothing but a Web browser. This mode of operation integrates perfectly with other SharePoint team Web site features, and it's a very good reason to save all documents in a team Web site in HTML format.
  • If the document isn't in HTML format, reviewers must download the document into the Office application that created it, choose Online Collaboration from the Tools menu, and possibly specify a discussion server by hand.
TIP
The Save As Web Page option in most Office applications saves all the properties and features that saving in the native application format does. That is, saving and opening a document in HTML format provides all the same features as saving and opening a document in .doc, .xls, or .ppt format.

Figure 35-6 shows Internet Explorer accepting discussion comments for a document. The Web visitor:

  1. Displayed the Document Library View form shown in Figure 35-3.
  2. Clicked the Edit icon for the deliverables file. This displayed the Edit Item Form page shown in Figure 35-4.
  3. Clicked the Discuss icon in the Edit Item Form page, and then displayed the Enter Discussion Text dialog box.
    4. Figure 35-6. The sticky note icons show where you can append comments to the document. Click one to display the Enter Discussion Text dialog box.
    Figure 35-6. The sticky note icons show where you can append comments to the document. Click one to display the Enter Discussion Text dialog box.

Click the Discuss icon to immediately display the Discussion bar shown at the bottom of Figure 35-6. (In Internet Explorer 5.5 or later, you might need to choose Explorer Bar from the View menu, and then choose Discuss.) The same command hides the Discussion bar if it's already on display. Here's how to use the buttons on this bar (note that these buttons will be available or unavailable depending on the type of document):

  • Discussions. Click this button to display a menu containing the following options:
    • Insert In The Document. Choose this command to display or hide all possible locations for inline sticky notes (those that appear inline with the document text). There's basically one sticky note location per paragraph. To add text to a new or existing sticky note, click it.
    • Insert About The Document. Choose this command to display an Enter Discussion Text dialog box where you can enter discussion comments about the document in general.
    • Refresh Discussions. Choose this command to retrieve a current set of discussion comments from the discussion server. Your display will then reflect changes other visitors might have made after you first displayed the page.
    • Filter Discussions. Choose this command to display discussion comments from only a certain participant, or within a certain time span.
    • Print Discussions. Choose this command to print the discussion comments.
    • Discussion Options. Choose this command to select the discussion server and the discussion fields to display.
    NOTE
    To host discussions on one server about documents on another, first open the document and then, on the Discussions toolbar, choose Discussion Options from the Discussions drop-down list. Finally, select the server that records discussion items from the Select A Discussion Server drop-down list.
  • Insert Discussion In The Document. Click this button to perform the same function as the Insert In The Document menu command just described.
  • Insert Discussion About The Document. Click this button to perform the same function as the Insert About The Document menu command just described.
  • Expand All Discussions. Click this button to display the title, text, and all other fields for each discussion comment.
  • Collapse All Discussions. Click this button to hide the contents of all discussion comments. A sticky note with a plus icon appears in place of each comment. To expand a particular comment, click the plus icon.
  • Show General Discussions. Click this button to display all general (non-inline) discussion comments made about an HTML document.
  • Previous. Click this button to display the previous discussion comment.
  • Next. Click this button to display the next discussion comment.
  • Subscribe. Click this button if you want to get an e-mail notification whenever someone updates either the current document or any document in the same folder.
  • Stop Communication With Discussion Server. Click this button if you want to disconnect an HTML document from the discussion server.
  • Show/Hide Discussion Pane. Click this toggle button to display or hide the discussion pane.
  • Close. Click this button to close the Web discussion.
  • Reply With Changes. Composes an e-mail message to the originator of a document, informing that person that you've added discussion comments to it.

Discussion text also appears—in almost identical format—when the original user opens the HTML file in Word. In fact, all discussion text from all users is merged seamlessly into place. (If no discussions appear, choose Online Collaboration from the Tools menu, and make sure the correct discussion server is specified.)


Using Subscriptions

Click any Subscribe link on a SharePoint team Web site page (such as the Document Library View page shown in Figure 35-3) to display the New Subscription page shown in Figure 35-7. To display the Document Subscription dialog box shown in Figure 35-8, click Subscribe on the Discussion bar. Both this dialog box and the New Subscription page serve the same function: you can subscribe to change notices on the current document or on any document in a specified folder (subject to filters); set notification criteria; specify your e-mail address; and indicate how long SharePoint Team Services should accumulate changes before sending them.

Figure 35-9 on shows a typical change notification message. Although the message in the figure provides only one notification, a single message can report multiple changes.

Figure 35-7. This Web page subscribes an e-mail user to change notifications for a given document or folder.
Figure 35-7. This Web page subscribes an e-mail user to change notifications for a given document or folder.

The notification process periodically scans a database and combines all notifications to the same recipient. The less often you choose to receive messages, the more notifications each message will contain.

The Subscription feature of a SharePoint team Web site isn't limited to Web Discussion comments that team members make using Internet Explorer. On the contrary, team members can subscribe for notification of almost any change to a team Web site.

Figure 35-8. This is the dialog box version of the Web page that appears in Figure 35-7.
Figure 35-8. This is the dialog box version of the Web page that appears in Figure 35-7.
Figure 35-9. A SharePoint team Web site sent this change notification automatically.
Figure 35-9. A SharePoint team Web site sent this change notification automatically.

Troubleshooting

Subscribers don't receive SharePoint team Web site change notifications

SharePoint team Web site members who subscribe to receive change notifications might not receive the expected mail for any of the following reasons:

  • Not enough time has passed. SharePoint team Web sites send notifications at intervals even if a team member chose to receive them "When A Change Occurs." These intervals apply to the entire Web server, and are thus something an administrator must control. The following settings are the defaults, but your server's configuration might vary:
    • Immediate Notifications. Every five minutes.
    • Daily Notifications. Midnight.
    • Weekly Notifications. Sunday midnight.
  • Server settings might be incomplete. The server administrator must configure SharePoint Team Services with the name of an SMTP mail server and an address that will appear in the From and Reply To fields of each outgoing message.
  • The Web Subscriptions feature might be disabled. The server administrator can turn off the Web Subscriptions features at the server level. Obviously, this inhibits the transmission of notification messages.


Using Discussion Boards

A SharePoint team Web site discussion board works a lot like an Internet newsgroup or a FrontPage Discussion Web. Team members can post new messages, respond to existing messages, and view messages in their entirety or in condensed lists. Whoever administers the team Web site can purge and correct messages, alter discussion board settings and defaults, and so forth. If security settings permit, team members can initiate and control their own discussion boards, and whoever posts a message can subsequently revise or delete it.

Figure 35-11 shows a summary view of a typical discussion board. To display this Web page:

  1. Choose Discussion Boards from the menu bar of any page in the SharePoint team Web site. This displays the Discussion Boards page shown in Figure 35-10, which displays the name and description of each available discussion board. The General Discussion board appears by default as part of every new team Web site. You can do the following:
    • To create additional boards, click the New Discussion Board link. This displays a New page that initializes a new discussion board.
    • To discuss a specific document on the Web, click Discuss A Document. This provides an entry point to the Web Discussions feature described in the section titled "Using Web Discussions" earlier in this chapter.
      • Figure 35-10. This page provides a selection list of SharePoint team Web site discussion boards. The single discussion shown appears by default in every new team Web site.
      Figure 35-10. This page provides a selection list of SharePoint team Web site discussion boards. The single discussion shown appears by default in every new team Web site.
  2. To view or modify the contents of an existing discussion board, click its icon or title. This displays a Discussion Board View page like the one shown in Figure 35-11. Figure 35-12 illustrates expanded view.
    3. Figure 35-11. Click a discussion board name or icon in Figure 35-10 to display a list of messages like this.
    Figure 35-11. Click a discussion board name or icon in Figure 35-10 to display a list of messages like this.
    Figure 35-12. Click the Expanded link in a Discussion Board View page (Figure 35-11) to display this view of the messages in a discussion board.
    Figure 35-12. Click the Expanded link in a Discussion Board View page (Figure 35-11) to display this view of the messages in a discussion board.

Here's how to use the various links on a Discussion Board View page:

  • Select A View. Click any link in this area (at the left of the page) to display the discussion in the format you want. Summary view, the default, is the mode shown in Figure 35-11. To create additional views , click the Modify Settings And Columns link near the right border of the page.
  • New Discussion. Click this link to initiate discussion on a new topic (that is, to create a new top-level message). Figure 35-13 shows the Web page that supports this function. (Remember, to create a new discussion board, click the New Discussion Board link in the Discussion Boards list, shown in Figure 35-10.)
    • Figure 35-13. This Web page starts a new discussion thread. To display it, click any New Discussion link.
    Figure 35-13. This Web page starts a new discussion thread. To display it, click any New Discussion link.
  • Filter. Click this link to limit the displayed messages based on criteria you specify.
  • Subscribe. Click this link if you want to receive e-mail notification whenever someone changes the contents of the discussion board.
  • Modify Settings And Columns. Click this link to display a Customization page that modifies the name of the discussion board, its description, its columns, or its views. The SharePoint team Web site keeps all this information in its database, and then adds it—on the fly—to any relevant Web pages.
  • Subject, Modified By, and Modified. Click any of these column headings to sort the display on that column.
  • Subject Titles. Click any entry in the Subject column to select and display it.
  • Modified By Names. Click any entry in the Modified By column to display information about that person.

Click the title of a message in the Discussion Board View page (Figure 35-11) to bring up the Display Discussion Article page shown in Figure 35-14. The title and body of the current message appear under the second menu bar.

Figure 35-14. Click the Subject text of any message to display both the message and its position in the thread.
Figure 35-14. Click the Subject text of any message to display both the message and its position in the thread.

The menu bar itself contains the following links:

  • Reply. Click this link to create a new message that responds to the current one. The new message appears beneath the existing one, indented one level to the right. Figure 35-13 shows the New Discussion page that appears when you click the Reply link.
  • Edit Item. Click this link to modify the current message. Depending on settings in effect for the discussion board, this might be possible only for an administrator or the person who originated the message.
  • Delete Item. Click this link to delete the current message. Again, this might be possible only for an administrator or the person who originated the message.
  • Go Back To Discussion Board. Click this link to back up one screen (usually to the Discussion Board View page shown in Figure 35-11).


Using Lists

Click the Lists link on the menu bar of any page in a SharePoint team Web site to display the Lists page shown in Figure 35-15. This is basically a list of all the lists in the current team Web site. All five lists itemized in the figure appear by default in any new team Web site.

Figure 35-15. This page identifies the lists in a SharePoint team Web site. The lists shown here appear by default in every new team Web site.
Figure 35-15. This page identifies the lists in a SharePoint team Web site. The lists shown here appear by default in every new team Web site.

Physically, a list is nothing more than a table in a database. Each list item is a table row and, as you've probably guessed, each list column is a table column. The SharePoint team Web site can create new tables (that is, lists), add columns, modify columns, and delete columns using Web pages that are part of (and integrated with) the team Web site.

Click the entry for any list in the List page to display a List View page like the one shown in Figure 35-16. The links on this page work much like those already described for document libraries and discussion boards (are you noticing a pattern?), but here's a brief summary:

  • Select A View. Click any link in this area to display the list in the format you want.
  • New Item. Click this link to display a page named New Item Form that adds a new item to the list.
  • Filter. Click this link to limit the displayed messages based on criteria you specify.
  • Export. Click this link to download a Microsoft Excel Web Query file that downloads the data in the list. Such files have a .iqy filename extension that's normally associated with Microsoft Excel. When you open such a file, Excel connects to the SharePoint team Web site database and downloads the data for the list you requested.

This is a highly useful approach because every time you open the Web Query file, Excel connects to the database server and downloads a fresh copy of the data in the list. This saves you from downloading fresh copies of the data manually. If you want to save a copy of the data as of some specific point in time, copy it from the query region and paste it into another spreadsheet.

Figure 35-16. Click a list name or icon in a List page (Figure 35-15) to display the items in the list.
Figure 35-16. Click a list name or icon in a List page (Figure 35-15) to display the items in the list.
  • Subscribe. Click this link if you want to receive e-mail notification whenever someone changes the contents of the list.
  • Modify Settings And Columns. Click this link to change the properties of the list. This includes the name, description, columns, views, and other settings.

The five lists shown in Figure 35-15 all contain different combinations of fields and different views. Nevertheless, they're all simple database tables that operate using the same basic principles.


Creating New Libraries, Discussions, and Lists

Click the Create link on any SharePoint team Web site menu bar to display the Create Page page shown in Figures 35-17 and 35-18. This page has the following options:

  • Custom List. This option, the first on the page, creates a list with only one column: Title. After the list exists, of course, you can display it and then click Modify Settings And Columns to add more columns, delete the Title column, or make any other changes you want.
  • Import Spreadsheet. This option, the last on the page, creates a list from data contained in a spreadsheet. Each row of spreadsheet data becomes one list record, and each column of spreadsheet data becomes a list column. The values in the first row will become the column names in the list.

When using this option, the SharePoint team Web site doesn't actually upload the spreadsheet as a file and then process it on the server. Instead, it opens Excel on your computer. Excel then opens the spreadsheet you specified, prompts for a range of cells to upload, and then transmits the values of those cells. This is much more flexible than uploading the entire file and converting its contents to a list.

All the other choices are basically variations of the Custom List choice, with the exception that each of them initializes the new list with a different collection of fields and formats. If one of these list types is nearly or exactly what you want, choose it. Otherwise, it'll probably be easier to use the Custom List choice than to delete all the extra columns another choice provides.


Creating a New Survey

Surveys are a particularly interesting type of list. As with all surveys, there are four basic steps:

  1. Decide what questions you want to ask.
  2. Design a form people can use to record their answers.
  3. Let the survey population fill out the form.
  4. Analyze the results.

Although a SharePoint team Web site can't choose questions for you, it does most of the work for the three remaining steps. This section explains how to create a survey and, along the way, how to perform a myriad of tasks useful for creating other lists as well. Here's the procedure:

  1. Click the Create link on any SharePoint team Web site menu bar. This displays the Create Page page shown in Figures 35-17 and 35-18.
  2. Click the Survey link shown in Figure 35-17. This displays the New Survey page partially shown in Figure 35-19.
    3. Figure 35-17. This Web page has links for creating lists, discussion boards, and document libraries of all kinds.
    Figure 35-17. This Web page has links for creating lists, discussion boards, and document libraries of all kinds.
    Figure 35-18. This is the bottom half of the Web page that starts in Figure 35-17.
    Figure 35-18. This is the bottom half of the Web page that starts in Figure 35-17.
    Figure 35-19. Click the Survey link in a Create Page page (Figure 35-17) to display this Web page for creating a new survey.
    Figure 35-19. Click the Survey link in a Create Page page (Figure 35-17) to display this Web page for creating a new survey.

    Fill out the input options as follows:

    • Name. Give the survey a short, descriptive name.
    • Description. If you want, enter a few sentences that explain the survey and its purpose.
    • Display This Survey On The Quick Launch Bar? Click Yes if you want all Quick Launch areas in the current SharePoint team Web site to contain a link to this survey. Otherwise click No. Use this feature judiciously; a Quick Launch bar containing hundreds of links isn't much of a time saver.
    • Show User Name In Survey Results? Click Yes if displays of survey results should include then name of each respondent. Click No to keep these names private.
    • Allow Multiple Responses? Click Yes if the same person can fill out the survey multiple times. Click No if each person can submit responses only once.

    Click the Next button when you're satisfied with your entries.

  3. The next page to appear is the Create New Question page shown in Figures 35-20 and 35-21. This Web page constructs the first survey question.
    4. Figure 35-20. This page adds a question to an existing survey. This is quite useful because creating a new survey creates only one question.
    Figure 35-20. This page adds a question to an existing survey. This is quite useful because creating a new survey creates only one question.
    Figure 35-21. This is the bottom half of the Web page that begins in Figure 35-20.
    Figure 35-21. This is the bottom half of the Web page that begins in Figure 35-20.

    Here's how to use the input options provided:

    • Question. Enter the text for the first question in the survey.
    • The Type Of Answer To This Question Is. Indicate what type of data constitutes the survey answer. Table 35-1 summarizes the result of each choice.

    Table 35-1. SharePoint team Web site Survey Answer Types

    Type of answer | Input form
Single Line Of Text | Text box
Multiple Lines Of Text | Text area box
Number (1, 1.0, 100) | Text box
Currency ($, ¥, £) | Text box
Date And Time (11/02/2001 12:15) | Combination of text box (for date) and drop-down lists (for hour and minute)
Lookup (Information Already On This Site) | Drop-down list
Choice (Menu To Choose From) | Drop-down list or option buttons
Yes/No (Check Box) | Check box

    The Lookup choice warrants a bit of additional explanation. This choice populates a drop-down list with all values that occur in a given list and column within the SharePoint team Web site. For example, this could include all Full Name values in the User Information list, all Titles in the Shared Documents library, all E-Mail Addresses in the Contacts list, and so forth. To configure a Lookup choice, you specify first the name of the list you want and then the column.

  4. The bottom half of the Edit Question page changes depending on the type of answer you specify. Figure 35-21 shows the format that appears if you choose Choice (Menu To Choose From). Enter each option as follows:
    • Require A Response To This Question. Click Yes if the survey respondent must answer the question before proceeding. Click No if answering the question is optional.
    • Type Each Choice On A Separate Line. Enter the list of choices. Separate choices by entering a carriage return.
    • Display Choices Using. Select either Drop-Down Menu or Radio Buttons depending on how you want respondents to view the choices.
    • Default Value. Enter the name of the choice that will be selected when the respondent first displays the Web page that contains this question.

    Click OK to finish creating the survey question.

  5. The Customization page partially shown in Figure 35-22 is the next page to appear.
Figure 35-22. This page modifies the overall properties of a survey.
Figure 35-22. This page modifies the overall properties of a survey.

It provides the following links:

    • Change General Settings. Displays a Change General Settings page very similar to the one shown in Figure 35-19. This provides a way to update these settings without recreating the survey.
    • Delete This Survey. Removes the survey forms, links, and data from the SharePoint team Web site.
    • Question (Click To Edit). Click the text of any question listed under this heading to change the text or format of that question, or to delete the question completely.
    • Add A Question. Click this link to add the second, third, and all subsequent questions in the survey. Basically, you must click this link and then repeat steps 3 and 4 once for each question.
    • Change The Order Of The Questions. Click this link to display a list of current questions and question numbers. The question numbers appear in drop-down lists that you can manipulate to put the questions in any order.

    Figure 35-23 shows how the Status Assessment survey appears to a survey respondent. This is a custom survey created by using the procedure just described, and not a standard element of every new SharePoint team Web site.

    Figure 35-23. This is how the survey looks to a survey respondent. The survey itself is just a list with a column for recording each answer.
    Figure 35-23. This is how the survey looks to a survey respondent. The survey itself is just a list with a column for recording each answer.

    Here's how to display this page:

    1. Click the Lists link on the menu bar of any page in a SharePoint team Web site.
    2. Click the survey's list title or its preceding icon. This displays the Overview page shown in Figure 35-24.
    Figure 35-24. The entry point for analyzing survey results is this Web page.
    Figure 35-24. The entry point for analyzing survey results is this Web page.

    The Overview page contains the following choices:

      • Respond To This Survey. Click this link to answer all the survey questions.
      • Export Results To A Spreadsheet. Click this link to download an Excel Web Query (.iqy) file that downloads the survey data into a spreadsheet.

      For more information about downloading list data, refer to "Using Lists" earlier in this chapter.

        • Subscribe. Click this link if you want to receive e-mail notification whenever someone completes or changes the survey.
        • Modify Survey And Questions. Click this link to change the properties of the survey. This includes the name, description, questions, and other settings. In short, it displays the Customization page partially shown in Figure 35-22.
        • Show A Graphical Summary Of Questions. Click this link to display a graphical summary of survey responses like the one shown in Figure 35-25.
        • Show All Responses. Click this link to display a textual listing of survey responses like the one shown in Figure 35-26.
        Figure 35-25. The graphical summary of survey responses looks like this.
        Figure 35-25. The graphical summary of survey responses looks like this.

        Creating other kinds of lists follows basically the same pattern as creating a survey. This is because, in fact, a survey is nothing but a list where each row is a survey response and each column an answer.

        Figure 35-26. This Web page displays all responses to a survey.
        Figure 35-26. This Web page displays all responses to a survey.


Administering SharePoint Team Web Site Settings

To modify and configure settings that apply to the entire SharePoint team Web site, click the Site Settings link in the menu bar of any team Web site page. This displays the Site Settings page shown in Figures 35-27 and 35-28.

On this page are the following:

  • Web Site Settings. The first portion of the Site Settings page controls the SharePoint team Web site's name, description, and home page layout. These are the links in this portion:
    • Change Site Name And Description. Click this link to display a Change Site Name And Description page that modifies the name and description of the SharePoint team Web site.
    • Customize Home Page Layout. Click this link to display a Home Page Layout page that determines which lists should appear in the center column of the SharePoint team Web site's home page and which should appear in the right column. (Recall that the left column of the home page contains the Quick Launch area, and that the Customization page for each list controls whether that list appears in the Quick Launch area.)

      • In general, only the most popular lists should appear on the home page. Team members should click Documents, Discussion Boards, or Lists to access the rest.

      Figure 35-27. The Site Settings page controls properties that affect an entire SharePoint team Web site.
      Figure 35-27. The Site Settings page controls properties that affect an entire SharePoint team Web site.
      Figure 35-28. This is the bottom half of the Site Settings page that appears in Figure 35-27.
      Figure 35-28. This is the bottom half of the Site Settings page that appears in Figure 35-27.
  • Web Administration. This portion of the Site Settings page contains links that add or remove users, create subwebs, and jump to overall site administration. Here are the links:
    • Manage Users. Click this link to display the Web page that adds, removes, or changes the roles of users who have access to one or more Webs on the current server.

      • If a SharePoint team Web site has no designated users, the Manage Users link and the Send An Invitation link described next won't appear. Instead, a Change Permissions link appears. Use the Change Permissions link to add one or more users. The Manage Users and Send An Invitation links will then appear.

      For more information about managing user access to FrontPage-based Webs, refer to "Managing SharePoint Team Services Users."

    • Send An Invitation. Click this link to run a wizard that gives team members access to the SharePoint team Web site and sends them e-mail. The e-mail describes the team Web site and invites them to participate.
    • Create A Subweb. Click this link to create a subweb within the SharePoint team Web site.
    • Go To Site Administration. Click this link to display the Administration page for the SharePoint team Web site.

    For more information about the Administration page for FrontPage-based Webs, refer to "Administering SharePoint Team Services Web Settings."

  • User Information. This portion of the Site Settings page provides options to modify your own SharePoint team Web site account or, if you're an administrator, the accounts of others. This portion's links are as follows:
    • Edit My Information. Click this link to display a Personal Settings page that shows and modifies your own user account information.

      • A hyperlink titled Edit User Information updates your full name, the address to use for sending e-mail, and any notes you care to provide.

      A hyperlink named Change Password changes your password.

      A hyperlink named Manage Personal Subscriptions displays all subscriptions you currently have in effect, and provides a way to delete those you no longer want.

    • View User Information. Click this link to display a list of users who have participated in or been invited to use the current SharePoint team Web site. This page contains hyperlinks to add or remove users, to invite new users, and to modify the full names, e-mail addresses, and notes pertaining to any known user.
  • Modify Site Content. This portion of the Site Settings page contains links to customize each document library, discussion board, and list in the current SharePoint team Web site. These links display the same pages that displaying the list and clicking Modify Settings And Columns would display.


Creating Custom List Pages

SharePoint team Web sites provide a wealth of methods for modifying their features and appearance. Even so, there might be times when you need more flexibility and need it badly enough to dive in and work directly with the Web pages. This section explains the options and techniques for doing just that.

TIP
The easiest way by far to create a new list is by clicking the new List link or the Team Web Site lists page. Similarly, the easiest way to modify a list is by clicking the Modify settings and columns link on its main Web page.

The first option, of course, is simply to open the SharePoint team Web site, find the team Web site page you want to change, and open it in Page view. This works subject to one large restriction: team Web site pages submit input to and receive output from a number of programs that run on the Web server, and you can't readily change these programs. (They're not ASP pages, for example). Therefore, anything you do that upsets the interface between team Web site pages and team Web site server programs breaks the site. Chapters 8 and 9 explained the structure of a SharePoint team Web site and gave some precautions for modifying constituent pages.

For more information about creating a SharePoint team Web site, refer to "Creating a SharePoint Team Web Site." For more information about creating, saving, and opening files in a SharePoint team Web site, refer to "Saving and Opening Files in SharePoint Team Web Sites."

Creating and Modifying Library View Pages

Figure 35-29 shows a Web page that's a curious mix of SharePoint team Web site and custom features. The menu bar and data in the center of the page come from the Share Documents library of a SharePoint team Web site. Nevertheless, the page contains custom formatting and could contain custom content as well. What's more, this is a page you can create yourself from scratch. Here's the procedure:

  1. Start FrontPage and create a new empty Web page.
  2. Choose Web Component from the Insert menu.
  3. When the Insert Web Component dialog box appears, choose Document Library View from the Component type list at the left, and a View Style from the Choose A View Style list at the right. Don't agonize over the View Style; you can easily change this later. Click Finish.
  4. When the Choose Document Library box shown at the left of Figure 35-30 appears, choose the SharePoint team Web site shared document library you'd like to display, and then click OK.
    5. Figure 35-29. You can construct replacement Team Web pages that look any way (and display any additional content) you want.
    Figure 35-29. You can construct replacement Team Web pages that look any way (and display any additional content) you want.

    When the Document Library View Properties dialog box shown at the right of Figure 35-30 appears, review the settings list at the right of each vertically arranged button.

    Figure 35-30. The dialog box at the left selects the document library that a Document Library View area will report. The dialog box at the right provides entry to all configurable aspects of a Document Library View area.
    Figure 35-30. The dialog box at the left selects the document library that a Document Library View area will report. The dialog box at the right provides entry to all configurable aspects of a Document Library View area.
  5. Click Library to choose a different document library. This redisplays the Choose Document Library box shown at the left of Figure 35-30 so you can choose a different library.
  6. Click Fields to change the information displayed for each document. The Displayed Fields dialog box shown at the left of Figure 35-31 appears.
    7. Figure 35-31. The Displayed Fields dialog box at the left controls which fields a Document Library View area will display. The Sort dialog box at the right controls which fields affect the item display order.
    Figure 35-31. The Displayed Fields dialog box at the left controls which fields a Document Library View area will display. The Sort dialog box at the right controls which fields affect the item display order.

    Make any necessary changes by using the following options:

    • Available Fields. This list contains all the fields in the shared document library that the current Web page doesn't already display. To display any of these fields, either double-click it or select it and click Add.
    • Add. Click this button to move any selected fields from the Available Fields list to the Displayed Fields list.
    • Remove. Click this button to move any selected fields from the Displayed Fields list to the list Available Fields. (Compared to the Add button, this is a case of "Second verse, played in reverse.")
    • Move Up. Click this button to move any fields selected in the Displayed Fields list one position higher in that list.
    • Move Down. Click this button to move any fields selected in the Displayed Fields list one position lower in that list. (A clear case of "What goes up...")
    • Displayed Fields. This box lists all the document library fields that the current Web page displays. To remove any of these fields, either double-click it or select it and click Remove.

    After some field names, the Displayed Fields dialog box displays a suffix that refers to a link. One of these, for example, is Edit (Link To Edit Item). If you included such a field on your page (that is, if you add it to the Displayed Fields list), a visitor can click the displayed value to invoke the corresponding action (for example, Edit).

    INSIDE OUT

    Unfortunately, linked fields in a Document Library View area suffer a major restriction: you have no control over the linked field's URL. If you plan to use such links, you must put the pages where the SharePoint team Web site software expects them to be, and that means replacing the standard pages created when you initialized the team Web site, document library, or list.

    Currently there appears to be no workaround for this restriction. Try searching Microsoft's knowledge base for more information; the URL is http://search.microsoft.com.

  7. Click Sort to change the initial order of the listed documents. This displays the Sort dialog box shown at the right of Figure 35-31, which provides the following controls:
    • Available Fields. This list contains all the fields in the shared document library that don't currently control the order of listed records. To use a field for sorting, either double-click it or select it and click Add.
    • Add. Click this button to move any selected fields from the Available Fields list to the Sort Order list.
    • Remove. Click this button to move any selected fields from the Sort Order list to the Available Fields list.
    • Move Up. Click this button to move any fields selected in the Sort Order list one position higher in that list.
    • Move Down. Click this button to move any fields selected in the Sort Order list one position lower in that list.
    • Change Sort. Click this button to reverse the order of any selected Sort Order fields (from ascending to descending or vice versa).
    • Sort Order. This box lists all the document libraries that the current Web page displays. To remove any of these fields, either double-click it or select it and click Remove.
  8. Click Filter to display only selected records from the current document library. This displays the Filter Criteria dialog box shown in Figure 35-32, which lists any criteria already in effect.

    9. The following options appear in the Filter Criteria dialog box:

    • Add. Click this button to define an additional filter. When the Add Filter dialog box shown in the center of Figure 35-32 appears, configure the following options:
      • Field Name. Select the field whose value you want to test.
      • Comparison. Specify the operator for the comparison: Equals, Not Equal, Less Than, and so forth.
      • Value. Enter the value that forms the basis for the comparison. For date fields, click Choose and then use the Date Value dialog box that appears at the right of Figure 35-32 to specify the value you want. Current Date means the date that the Web server processes the visitor's request. Specific Date means a date you type by hand.

        For non-date fields, enter the desired value in the text box provided.

      • And/Or. Choose And if other filters, as well as this one, must be true for the record to be selected. Choose Or if this is one of several filters, any of which, if true, are sufficient to select the record.
    • Modify. Click this button to change an existing filter. This displays a Modify Filter dialog box that looks and works very much like the Add Filter dialog box just described. This button is dimmed unless you've already selected a filter.
    • Remove. Click this button to remove an existing filter. The button is dimmed unless you've already selected a filter.
    Figure 35-32. The Filter Criteria dialog box lists any current restrictions on the items displayed. Click its Add button to display the Add Filter dialog box, which adds a new filter to the list. If the filter involves a date field, click the Choose button to display the Date Value dialog box.
    Figure 35-32. The Filter Criteria dialog box lists any current restrictions on the items displayed. Click its Add button to display the Add Filter dialog box, which adds a new filter to the list. If the filter involves a date field, click the Choose button to display the Date Value dialog box.
  9. Click Options to display the View Options dialog box shown in Figure 35-33. This dialog box configures the following settings:
    • Choose A Style. Choose a page layout design for the document library records.
    • Toolbar Type. Choose the type of toolbar that will appear above the library listing:
      • Full Toolbar. Choose this option to display a toolbar with five links: New Document, Upload Document, Filter, Subscribe, and Modify Settings And Columns.
      • Summary Toolbar. Choose this option to display a toolbar with two links: Shared Documents and Add New Document.
      • None. Choose this option if you don't want to have a toolbar at all.

      • The links on these toolbars follow the standard conventions that apply to SharePoint team Web sites. You can't, for example, change them so they jump to custom pages.

      Figure 35-33. Use this dialog box to specify the style, toolbar type, item limit, and zero-items message for a Document Library View area.
      Figure 35-33. Use this dialog box to specify the style, toolbar type, item limit, and zero-items message for a Document Library View area.
    • Display All Items Together And Limit The Total Number To. Select this option if you want the query to display all results on a single Web page. To avoid runaway queries, you should also enter a workable maximum record count in the accompanying text box.
    • Display Items In Sets Of This Size. Select this option if you want the query to display a specific number of records on the first Web page, and then provide a Next link that displays the next group of like records.
    • Text To Display If No Matching Items Are Found. Enter the message you want visitors to see if the library is empty or fails all filtering criteria. (For example, you might display "Thanks, you've just deleted our last six months' work.")
  10. When you're done adjusting options, click OK on the Document Library View Properties dialog box (the right side of Figure 35-30).

At this point your new Web page should display a recognizable SharePoint team Web site document list, albeit crudely formatted. Figure 35-34 provides an example. You can apply any formatting or add any additional content you want.

Figure 35-34. By default, creating a new Document Library View area provides very little formatting.
Figure 35-34. By default, creating a new Document Library View area provides very little formatting.

To change any structural aspect of the Document Library View area, double-click it or right-click it and choose View Properties from the shortcut menu. Both actions display the Document Library View Properties dialog box already described. It works the same for changing a view area as it does for creating one.

To perform more radical surgery, right-click the Document Library View area and choose Layout Customization View from the shortcut menu. This changes the Page view display to the format shown in the background of Figure 35-35. The library view area in the figure now looks like a table with six rows, but four of them are comments and two are very special. (If you chose a different layout style, your row numbers might differ, but the concepts are the same.)

INSIDE OUT
After you've switched a Document Library View area to Layout Customization View, you can change it back by right-clicking the area and choosing Live Data View from the shortcut menu. When you do so, however, FrontPage discards any changes you made while in Customization view. This is the price for making changes in a more flexible way than Live Data View can accommodate. Think carefully before changing back to Live Data View.
Figure 35-35. The List Field component displays the name or current value of any field in a document library or list.
Figure 35-35. The List Field component displays the name or current value of any field in a document library or list.

In the library view area:

  • The comment rows are 1, 3, 5, and 6.
  • Row 2 contains the column headings. This row appears only once whenever a visitor displays a page that contains it.
  • Row 4 contains a template for record values. The SharePoint team Web site software duplicates this row once for every record it displays from the given document library.

By default, each cell in rows 2 and 4 contains a special component called a List Field. These components work a lot like Confirmation Field components in a Confirmation form, or Column Value components in a Database Results region: that is, they're placeholders that the SharePoint team Web site software replaces with actual values when a Web visitor requests the page. You can use List Field components to display any document library field names or field values you want.

Double-clicking an existing List Field component displays the List Field Properties dialog box shown in the foreground of Figure 35-35. Right-clicking the component and choosing either List Field or List Field Properties accomplishes the same thing. Use the following fields to modify a List Field component:

  • Field To Display. Select the document library field that the List Field component should display.
  • Display Options. Select Show The Field Name to display the name of the field. This is the usual setting for List Field components used in the heading area of the List View area.

Select Show The Field Data to display the contents of the field. This is the usual setting for List Field components used in the repeating area of the List View area.

To add a List Field component to an existing List View area, set the insertion point where you want it to appear, choose Form from the Insert menu, and then choose List Field.

Creating and Modifying List View Pages

If you can create and modify Library View pages, you can create and modify List View pages. The procedures are nearly identical. To get started:

  1. Start FrontPage and create a new empty Web page.
  2. Choose Web Component from the Insert menu.
  3. When the Insert Web Component dialog box appears, choose List View from the Component Type list at the left, and a View Style from the Choose A View Style list at the right. Don't agonize over the View Style; you can easily change this later. Click Finish.

Did you catch the difference? In step 3, you choose List View rather than Document Library View from the Component Type list. That's it. Virtually everything that pertains to document libraries pertains to lists as well. This is just what you should expect, because a Document Library View doesn't actually display the documents in a library; it displays information from the SharePoint team Web site list that describes the documents.

There are a few other differences, such as the fact that SharePoint team Web site toolbars for document libraries and ordinary lists are slightly different. Keep an eye out for these and you shouldn't have any problems.

Creating and Modifying List Forms

SharePoint team Web sites use a specialized Web component to create three of their most common forms. You can insert this component, and thus initialize such a form, by following this procedure:

  1. Start FrontPage and create a new empty Web page.
  2. Choose Form from the Insert menu, and then choose List Form. This displays the List Or Document Library Form dialog box shown in the foreground of Figure 35-36.
  3. Set the options in the List Or Document Library Form dialog box as follows:
    • List Or Document Library To Use For Form. Select the list or document library you want the form to update.
    • New Item Form (Used To Add New Items To The List). Select this option to create a form that adds new items to the list or document library.
    • Edit Item Form (Used To Edit Existing List Items). Select this option to create a form that modifies existing items in the list or document library.
    • Display Item Form (Used To View List Items). Select this option to create a form that displays items in the list or document library.
    • Show Standard Toolbar. Select this box to display the standard SharePoint team Web site toolbar for the form type.
  4. Click OK to create the form.

As with Document Library View and List View components, Page view should now display a crudely formatted but recognizable SharePoint team Web site form. You can add whatever formatting and content you want, but there isn't much you can do to the form itself except double-clicking it to redisplay the List Or Document Library Form dialog box.

Figure 35-36. This dialog box controls the properties of a SharePoint team Web site form page.
Figure 35-36. This dialog box controls the properties of a SharePoint team Web site form page.

Again, as with Document Library View and List View components, you have very little flexibility regarding the location of pages that contain SharePoint team Web site forms. Specifically, you must locate forms that pertain to lists as follows:

Form Type | Location relative to start of Web
New item form | /Lists/<list-name>/NewForm.htm
Edit item form | /Lists/<list-name>/EditForm.htm
Display item form | /Lists/<list-name>/DisplayItem.htm

Here are the locations for forms that pertain to shared document libraries:

Form Type | Location relative to start of Web
New item form | /<library-name>/Forms/NewForm.htm
Edit item form | /<library-name>/Forms /EditForm.htm
Display item form | /<library-name>/Forms /DisplayItem.htm

These, of course, are the locations of the forms that appear automatically when you create a new document library or list. You can create pages from scratch and overlay the default ones, but in most cases it'll be easier (and safer) to just open the default pages and modify them. That's why Figure 35-36 shows a default list form open in the background.


In Summary...

This chapter explained how team members can use the features of a SharePoint team Web site to share documents and coordinate their activities. It also explained how to administer such a site, and how to create custom pages that perform standard functions.

The next chapter explains some terms and concepts that pertain to the Internet in general and Web servers in particular. This is background material that, if you had need of it, you've probably skipped ahead and read already. Nevertheless it has to go somewhere, and it might as well be here.


Getting Started with Visio

Microsoft Visio Standard and Microsoft Visio Professional 2002 provide a broad range of diagramming solutions that help people visualize and communicate ideas, information, and systems. You don't need to be a professional illustrator or drafter to get professional results with Visio. Whether you need a simple flowchart or a multiple-page, highly detailed technical drawing, you can get up to speed quickly by dragging and dropping predefined shapes. Visio includes thousands of SmartShapes symbols that allow you to easily assemble business diagrams, technical drawings, and information technology models. Automatic layout and alignment tools provide design assistance that ensures professional results.

As a member of the Microsoft Office XP family of applications, Visio is designed to complement Excel, Word, and PowerPoint. Visio diagrams stand on their own or increase the impact of your Office documents. This chapter introduces key concepts and the different versions of Visio, lists new features, and helps you get started working efficiently with this powerful application.


What Is Visio?

Some people might think that only artists can—or need to—draw. Visio can help you toss that belief out the door. Visio is a business and technical drawing and diagramming program that anyone can use to communicate concepts, procedures, product information, specifications, and more. Most of us respond to visual images on the Web and in the reports and e-mail we see every day, even when the accompanying text doesn't grab our attention. Images such as charts, tables, process flows, floor plans, Venn diagrams, and so on use text and symbols to convey information at a glance. You could call this type of image an information graphic, and a good one can clarify an idea and help you to understand even complex concepts more quickly. Visio is designed to help you convey information visually—without requiring that you know how to draw.

Visio does this by giving you solutions to your diagramming needs: ready-to-use templates that set up a page appropriately and open stencils that contain predrawn shapes. For example, Visio includes several flowcharting solutions as Figure 1-1 shows. If you start with the Basic Flowchart template, Visio displays a new, blank drawing page and opens several stencils that contain the shapes you need to create a flowchart. You drag a shape from the stencil onto the page, which has a grid that helps you align your diagram. You might have heard this process referred to as "drag and drop." That is the fundamental idea behind everything you do in Visio. Perhaps even more important is the idea of connecting shapes. When you drag additional shapes onto the page to create a diagram such as a flowchart, special lines called connectors connect the shapes and stay attached when you move shapes around. By arranging and connecting shapes on the page, you can rapidly assemble a diagram that you can drop into another document, such as a report or presentation slide; save as a Web page; or print.

Figure 1-1. Visio provides you with diagramming tools that are specific to the type of drawing you choose to create.
Figure 1-1. Visio provides you with diagramming tools that are specific to the type of drawing you choose to create.

When you talk about dragging shapes, it sounds pretty simple. However, this simplicity is deceptive. The built-in solutions you'll find in Visio range from straightforward block diagrams to complex relational data models. The advantage to you is that no matter what type of information you want to present visually, Visio has a way of getting it done.

InsideOut
The Visio team has conducted much usability research in past years that indicates a consistent theme: Visio often overwhelms new users with the number of new terms they have to learn. Even if you're very comfortable with other Microsoft Office applications, you can expect to wrestle a bit with Visio terminology at first. Part of the difficulty is that the term template is often used interchangeably with drawing type and solutions in different documents and on the Web site. Moreover, the part of the Visio screen where stencils appear is labeled Shapes, and shapes themselves are sometimes called SmartShapes symbols, masters, or master shapes. If you're confused, you're not alone—but don't worry. As you use Visio, you'll pick up the lingo you need to know. This book tries to use the terms templates, stencils, shapes, and master shapes consistently.

Two Versions: Visio Standard and Visio Professional

Visio comes in two flavors: Visio Standard 2002 and Visio Professional 2002. The two versions differ in their intended audience, which is reflected in the number and type of templates and shapes they include. Visio Standard is intended for business professionals who need to communicate visually about their organization's people, projects, and processes. The following visual solutions are included:

  • Block Diagram. Includes the Basic, Block, and Block with Perspective templates. These are useful for showing all types of relationships and hierarchies and provide the basic arsenal of information graphics tools.
  • Flowchart. Includes templates for creating audit diagrams, basic flowcharts, cause and effect diagrams, cross-functional flowcharts, mind mapping diagrams, total quality management (TQM) charts, and workflow diagrams.
  • Form and Chart. Includes templates for designing business forms; creating quick pie, line, and bar charts and graphs; and creating marketing diagrams.
  • Office Layout. Provides a quick way to design accurate, to-scale office and furniture layouts.
  • Map. Includes templates for creating simple street maps and attractive 3-D maps.
  • Network. Includes shapes designed to resemble common network topology and devices. Useful for planning and documenting small to medium-sized networks.
  • Organization Chart. Includes intelligent shapes that "know" their position in an organization, so that reporting structures stay in place. You can even use the Organization Chart Wizard to automatically build a chart from a spreadsheet or database without having to draw a thing.
  • Project Schedule. Includes templates for creating PERT charts, Gantt charts, timelines, and calendars, so you can keep your projects on track.

Visio Professional is intended for technical professionals—IT personnel, database and software programmers, and engineers—and includes many industry-specific solutions. If you have Visio Professional, you have all the templates and shapes that are included with Visio Standard as well as the following solutions geared specifically for the technical audience:

  • newfeature! Building Plan. Includes templates for creating plan-view drawings of corporate offices and industrial manufacturing facilities. Designed for space planners and building engineers, this solution lets you create floor plans, home plans, plant layouts, reflected ceiling plans, site plans, and the building services schematics that support them.
  • Database. Includes templates for communicating database designs using multiple notations and is intended for database professionals. With the Database Model Diagram template, you can even reverse engineer and get support for leading client/server and desktop databases.
  • newfeature! Electrical Engineering. Includes a variety of templates used by electrical engineers for creating electrical and electronic schematics, wiring diagrams, and logic diagrams.
  • newfeature! Mechanical Engineering. Includes templates for diagramming fluid power control systems and hydraulic or pneumatic circuits as well as part and assembly drawings.
  • Network. Includes further templates for creating high-level, logical diagrams and for designing local area networks, wide area networks, wiring closets, server rooms, and telecommunications structures. In addition, you can create diagrams of Microsoft Active Directory, Novell Directory Services (NDS), and other LDAP-based directory structures.
  • newfeature! Process Engineering. Includes templates for assembling detailed piping and instrumentation diagrams (P&IDs) and process flow diagrams (PFDs) used by many chemical and industrial engineers.
  • Software. Includes templates for major object-oriented software notations, including the full Unified Modeling Language (UML) 1.2 notation. In addition, you can diagram data flows, Windows user interfaces, COM and OLE objects, and more.
  • Web Diagram. Includes templates for automatically mapping Web sites and conceptual shapes for planning new designs.

With everything from block diagrams to UML software models, Visio satisfies a wide range of diagramming needs for a diverse audience. This book covers both products, which means that some chapters won't apply to you if you have Visio Standard. You'll see a note when the information in a chapter applies to Visio Professional users only.

Microsoft Office Diagram Gallery vs. Visio

The Microsoft Office Drawing Toolbar and Diagram Gallery deliver straightforward drawing tools right in Microsoft Office XP applications such as Excel, Word, and PowerPoint. You can use these tools to create simple drawings and sketches in your Office documents, so why fire up Visio at all? It's a question of scale. For that quick, two-step process chart, use the tools in Microsoft Office. For anything more complex, it's probably more efficient to use Visio, a dedicated drawing application—and you can more easily reuse the results.

Drag-and-Drop Diagramming with Shapes

If you're new to Visio, you may think shapes look a lot like clip art. In fact, shapes have built-in intelligence—their "smarts"—that makes them work in uniquely appropriate ways. For example, you can use auto-routing lines to connect process shapes in a flowchart. When you move a process shape, all the lines stay connected and reroute around other shapes as necessary, as Figure 1-2 shows. What a huge time savings that represents! The truth about shapes is that you shouldn't notice how smart they are, because they just work the way you expect them to.

Shapes are smart in other ways, as well. For example, door shapes in an office layout can swing in or out by using a single command; valve shapes can rotate into place automatically on a pipe; milestone shapes can shift position on a timeline as you adjust dates. And these are just a few examples. The type of drawing you create determines the type of shape smarts you'll see. On one hand, this means that Visio can seem inconsistent. Techniques that work with flowchart shapes may not apply to organization chart shapes. On the other hand, a template and the shapes it provides are designed to make it easy for you to create a specific type of drawing. Visio is not a fixed menu; it's more like a buffet table with many options for combining great ingredients.

Figure 1-2. When you drag a shape that's connected to other shapes, Visio's built-in
Figure 1-2. When you drag a shape that's connected to other shapes, Visio's built-in "intelligence" takes care of the connections for you and reroutes lines automatically.

Diagramming in Visio Standard vs. Modeling in Visio Professional

Is Visio the ideal tool for busy business users who want to assemble great-looking graphics in no time? Yes. Is Visio the ideal tool for modeling real-world systems and tracking detailed component specifications? Yes. Are we talking about the same product? Yes! It's a matter of perspective. The diagrams you can create with Visio Standard tend to be conceptual diagrams—shapes that show connections and relationships, as in flowcharts and timelines. Visio Professional includes more modeling capability. Shapes represent real-world objects with attributes, such as 10-foot walls that enclose office number 4N171, which is occupied by Steve Alboucq, whose title is vice president.

Why would you need to understand the difference between diagramming and modeling? If you only ever use Visio to create one type of diagram, it doesn't matter and you can ignore this section. However, if you use several Visio templates, you will probably discover that you need different methods for working with different types of diagrams, and this can make Visio seem hard to use. Despite the "drag-drop-done" philosophy, which says that you just click shapes into place and Visio practically draws for you, some Visio templates do not work that way. If you know this up front, maybe you won't be quite so frustrated when you can't seem to get a shape to look or work the way you want.

One of the primary goals of this book is to help you work successfully in any Visio diagram type, regardless of a solution's idiosyncrasies. It can help to think of each different diagram type or solution as a separate application with unique rules.


What's New in This Release

You won't find many new shapes in Visio 2002, although there are a few. The real difference with this release is in a more polished look up front and more refined engineering behind the scenes. It all works—this is a better-tested product than Visio 2000, and it shows in improved performance and fewer bugs. In addition, because the Visio development team is now part of Microsoft, they had access to tools used by the Microsoft Office XP team, which means that Visio integrates better than ever with Office products. Visio 2002 includes the following new shapes and templates:

  • 3-D directional maps
  • Curved wall shapes for floor plans
  • Additional network shapes
  • Updated Windows user interface shapes (Visio Professional only)
  • Enterprise Application template (Visio Professional only)

The following new features enhance the way you work in Visio:

  • Better Web pages from Visio diagrams. The improved Save As Web Page command delivers crisper HTML and superior GIF and JPEG graphics. Improved hyperlinks add navigation to your diagrams, and now you can even add multiple hyperlinks to one shape. When you save your diagram as a Web page, the hyperlinks are positioned more accurately. A new HTML custom property frame saves a diagram's custom properties, too. Visio also exposes its Web functionality through its API so that developers can save multiple Visio files as HTML in a batch process.
  • New photo editing tools. You can refine imported bitmaps in Visio with tools for adjusting contrast and brightness. You can also directly import pictures from digital cameras.
  • Smoother graphics and text. New support for smooth fonts makes on-screen text easier to read in Visio, thanks to Microsoft ClearType technology. Visio also supports transparent fill colors and smoother gradients, so shapes look better.
  • Better data storing and reporting capabilities. Improved support for defining the custom properties stored with shapes makes it easier for you to customize and store shape specifications, asset information, and other data. Then you can use the new Report tool to define reports based on shape properties. When you generate your report, you can output it as a Visio shape, an Excel document, an HTML file, or as XML format.
Note
Many Visio solutions have been enhanced as well. For example, the Office Layout template in Visio Standard and the Building Plan solutions in Visio Professional include new curved wall shapes and smoother performance, and you can generate timelines and Gantt charts by importing project tasks and milestones from Microsoft Project. Other new, shape-specific and template-specific improvements are mentioned throughout this book in the chapters about particular solutions.

Visio includes numerous enhancements across the board to make the work environment more like other Office XP products, including the following new tools:

  • AutoCorrect (IntelliSense). You can insert, correct, and format text as you type, just as in Word.
  • Auto save and recovery. Like Word and PowerPoint, Visio now can save your drawing files automatically at specific time intervals. If an error occurs, the recovered file is opened, giving you the option of discarding the file, saving it over the original, or saving it as a separate file.
  • Answer Wizard Help. You can type questions in a "How Do I?" field just as you do on the Office XP menu bar. The docked Help pane tiles alongside your drawing page for easy access to answers while you work.
  • Clip Gallery Live. If you have Office XP installed with Visio, you can directly access the Office Clip Gallery Live from within Visio.
  • Common color palette. Visio diagrams look even better when added to your Office documents, because Visio now uses the same color palette as Office.
  • Task panes. Visio works just like Office, with easy access to important tasks in a single integrated view. From the task pane, you can perform in-depth searches across documents as well as open an existing diagram or document or create a new one.
  • Personalized (short) menus. Adaptable menus bring commonly used commands to the top while hiding the others. If you pause while displaying a menu, Visio expands the menu to reveal all commands. Commands you use are added to the menu, "personalizing" it.
Tip - Restore Full Visio Menus

Use the Tools, Customize command to restore menus to their Visio 2000 appearance. On the Options tab, select the Always Show Full Menus check box.

For details about new features in the Visio Setup program, see "New Installation Features".

What You Won't Find in This Release

In every version of Visio software since the first release, the Visio team has been careful not to remove features if at all possible. Command names may change or functionality may evolve or move within the product, but shapes and templates are usually not removed. Until this release. Several templates that used to ship with Visio Professional are no longer included with the product, although you may still be able to get them from the http://www.microsoft.com Web site. Entire products that you used to be able to purchase—Visio Technical and Visio Enterprise—are no longer available in that form, but their contents can still be found elsewhere. The net result is that the Visio product line is easier to understand, but if you were partial to Visio's geographic maps, it just became a little tougher to create them.

For details about the templates and stencils you will find in this version, see Appendix B, "Template and Stencil Reference."

Templates That Have Moved

All the templates, shapes, and add-ons that were included with Visio 2000 Technical Edition are now a part of Visio Professional 2002. Some templates that were included with Visio 2000 Standard Edition are not included with Visio Standard 2002. Instead, they have been added to Visio Professional. The templates that moved from Standard to Professional are Data Flow Diagram, IDEF0 Diagram, and SDL Diagram from the Flowchart solution.

Other templates that used to be included with Visio 2000 are no longer shipped with the product, but may be available through the Web. Microsoft plans to make the following templates available by download:

  • Database templates. Bachman, Chen ERD, Martin ERD, and Booch OOD.
  • Software templates. Fusion, Jacobsen Use Cases, Nassi-Schneiderman, Rumbaugh OMT, Shlaer-Mellor, SSADM, System Structure, and Yourdon And Coad.

Features Deleted from Visio

Some tools, wizards, and add-ons that were available in Visio 2000 have been removed from Visio 2002 or have been replaced by improved features. In some cases, Microsoft plans to make an add-on or tool available as a download; it's worth visiting the Web site to see what's available. Table 1-1 sorts out what went where.

Table 1-1. Features No Longer in Visio

Deleted Feature | Status
Custom Properties Editor | Replaced by Define Custom Properties dialog box
Chart Shape Wizard | No longer supported
Datasheets | No longer required by the redesigned Process Engineering solution
Internet Diagramming Wizard | No longer required by the redesigned Web Site Map template
Netlist Generator | May be available as a Web download
Network Database Wizard | Replaced by improved tools available in new Visio Network Tools add-on
Network Diagram Wizard | Replaced by improved tools available in new Visio Network Tools add-on
Office toolbar macros | Technology rendered irrelevant by Windows 2000 enhancements
Page Layout Wizard | No longer supported
Property Reporting Wizard | Replaced by new Report tool
Property Line add-on | No longer supported
Print ShapeSheet | May be available as a Web download.
Shape Explorer | Replaced by Shape Gallery
SmartShape Wizard | May be available as a Web download
Stencil Report Wizard | May be available as a Web download
Synchronize Shapes add-on | No longer supported
Valve Builder | May be available as a Web download

Information for Visio Enterprise Customers

The advanced network diagramming and documentation solutions formerly found in Visio 2000 Enterprise Edition are now available in Microsoft Visio Network Tools. This add-on to Visio Professional also provides online access to additional network documentation updates and information via the Visio Network Center.

The database and software modeling technology that was previously found in Visio 2000 Enterprise Edition has been relocated to Microsoft Visual Studio.NET Enterprise Edition. So if you want to graphically describe database schemas and software applications and generate code based on models, you can now do so using the Application Design Workbench in Visual Studio.NET. You will find numerous updated features as well, including support for SQL Server 2000 and Visual Studio.NET programming languages.

InsideOut
Why was Visio Enterprise discontinued? This happened for several reasons; the primary reason was to simplify the Visio product line for everyone. Four editions were too confusing. The idea with the Visio Network Tools add-on is that the IT audience who uses Visio Professional can obtain new and updated solutions on a continual basis from the Visio Network Center Web site. In addition, customer research indicated that the vast majority of Visio users who need software and database modeling functionality also use Visual Studio, so Microsoft thought it made sense to integrate these two technologies.

Information for Visio Technical Customers

Visio Technical is now included in Visio Professional. The Visio 2000 Professional and Technical editions were combined into a single product in response to feedback from Visio Technical customers, whose diagramming needs span multiple technical disciplines, including both IT and facilities management.


Starting with the Diagram Type You Want

Many people approach Visio as they would Word or Excel and expect a blank page to appear. With Visio, though, you're better off starting with a template. The page may still be blank at first, but at least by basing it on a template, the appropriate set of shapes will appear. It's easy to select the template you want, because when you start Visio, the Choose Drawing Type pane shows you previews of the types of diagrams typically created with a particular template, as Figure 1-3 shows.

Figure 1-3. When you start Visio, you can preview sample diagrams for each template within a category.
Figure 1-3. When you start Visio, you can preview sample diagrams for each template within a category.
Tip - Choose a Drawing Type

When you're working in Visio, you can display the Choose Drawing Type pane without closing and reopening the program by clicking File, New, Choose Drawing Type. A shortcut to the categories of templates is to click File, New, and then click a category to display a submenu of templates.

Starting with a Template

You can start Visio with a new, blank drawing, which opens only a drawing page and no stencils. However, starting with a template provides important advantages that help you work more efficiently:

  • A template can help you solve formatting and design problems in advance. It sets up the appropriate size and orientation of the page for the type of diagram you want to create.
  • A template opens the stencils that contain the shapes you'll need to use. It includes diagram-specific styles for formatting the shapes.
  • A template displays rulers and a grid on the drawing page and sets them appropriately for the type of diagram. Templates with "US Units" in the name start a page that displays a ruler with inches; otherwise, metric units are used.
  • Some templates add special-purpose menus and toolbars. The only way to create certain types of diagrams in Visio and take advantage of timesaving features is to start with the appropriate template.

For all these reasons, you're almost always better off using a template. It sets up your working environment for you, so all you have to do is add shapes and text.

To start a diagram with a template:

  1. On the Start menu, click Programs, and then click Microsoft Visio.
  2. In the Choose Drawing Type pane, click a drawing type under Category.

    Pictures of specific diagram types appear in the area under Template. Each picture represents a sample diagram created using that template.

    Note
    When you install Visio, you have the option to install metric versions of the templates and add-ons. If you choose this option, you'll see two copies of each template in the Choose Drawing Type pane: one labeled "(US Units)" and one not. The only difference is whether the page is set up for United States units (inches) and page size or metric units and page size.
  3. Click the picture that represents the diagram type you want to create, and then click OK.

    Visio opens a new drawing page. Stencils containing shapes appropriate for that diagram type appear on the left, as Figure 1-4 shows.

    Note
    Visio templates establish other page settings that can vary from diagram to diagram. For example, some templates adjust the way shapes snap into position, how they glue to one another, whether drawing pages have backgrounds, and more. This book discusses template-specific settings in the chapters that cover different diagram types.
    Figure 1-4. If you start a new diagram based on the Basic Flowchart (US Units) template, Visio opens a letter-sized drawing page with three stencils.
    Figure 1-4. If you start a new diagram based on the Basic Flowchart (US Units) template, Visio opens a letter-sized drawing page with three stencils.

Starting in the New Drawing Pane

The Choose Drawing Type pane is a great way to learn about Visio's offerings, but after you've created a few diagrams, you may prefer to work in the New Drawing task pane, shown in Figure 1-5. Like the list of recently opened files that appears on the File menu, the task pane shows you diagrams you've opened, templates that you've used recently, and options for starting a new diagram based on a template.

Figure 1-5. The New Drawing task pane provides shortcuts for creating new diagrams and opening existing ones.
Figure 1-5. The New Drawing task pane provides shortcuts for creating new diagrams and opening existing ones.
InsideOut
The New Drawing task pane repeats options that are available in the Choose Drawing Type pane and from the File menu and toolbars, so it may seem redundant. If you prefer not to see the New Drawing task pane when you start Visio, clear the check box at the bottom of the pane labeled Show At Startup. Then you can use the File menu to choose a drawing type. However, the New Drawing task pane has other uses. You can use it to display search options for locating files. Click the drop-down arrow on the New Drawing task pane's title bar, and then click Search.


Touring the Visio Window

When you first start Visio, you see the menus and toolbars across the top, stencils along the side, rulers around the page, and the status bar below. In fact, a great deal of visual information is presented all at once, and all of it has built-in help in the form of ScreenTips. Pause your mouse over a toolbar button or a shape, and a small box or balloon containing a helpful tip appears, as shown in Figure 1-6.

Figure 1-6. Many screen elements include tips that appear when you pause the mouse over an item. A shape's tip describes a shape's purpose.
Figure 1-6. Many screen elements include tips that appear when you pause the mouse over an item. A shape's tip describes a shape's purpose.

newfeature! If you've upgraded from a previous version of Visio to Visio 2002, one of the biggest changes you'll notice are the new, personalized menus, which may be disorienting at first. Commands you expect to see may not appear. By default, Visio displays only the most commonly used commands. To see the complete list, point to the double-arrow at the bottom of the menu, and after a moment, the full menu appears. As you use commands, Visio adds them to the menu. To work with the full menus all the time, click Tools, Customize. On the Options tab, select the Always Show Full Menus check box.

Another important element of the Visio window is the status bar. As you work, changes you make to shapes are reflected on the status bar, as Figure 1-7 shows.

Figure 1-7. As you drag a shape on the drawing page, the status bar tells you its exact position.
Figure 1-7. As you drag a shape on the drawing page, the status bar tells you its exact position.
Tip - Customize the Visio Desktop

Stencils don't have to be green, pages don't have to be white, and the page background (or pasteboard) doesn't have to be light blue. To customize any of these colors, choose Tools, Options, and then click the View tab. Under Color Settings, you can choose different colors for stencils, pages, and other objects. Choices you make here change the Visio working environment until you choose different colors.

Using the Toolbars for Drawing and Formatting

Many of the most common editing tasks have a shortcut on the toolbars that Visio displays by default: Standard and Formatting. The Standard toolbar contains many of the same buttons that you see in other Microsoft Office programs. The Formatting toolbar contains style lists and options for formatting the appearance of text, lines, and fill—the interior color of shapes. You can use the Customize command on the Tools menu to add and remove commands from toolbars so that the shortcuts you use most are at hand.

Visio has a toolbar for most every task. To choose the toolbars you want to work with, click View, Toolbars. A check mark appears beside the toolbars that are displayed. Click to display the toolbar you want. If you want to turn off the display of a toolbar, click a checked toolbar.

What if you prefer to display toolbars vertically? You can dock and float toolbars (and other windows) by dragging them where you want. Toolbars are docked when they are attached to the side of the window. Usually they're docked along the top, but you can drag them to an edge or the bottom of the Visio window. When you float a toolbar mid-screen, it displays a title bar as you see in Figure 1-8.

Figure 1-8. You can drag a toolbar to a more convenient location. To dock it again, drag it back to the top, bottom, or side of the Visio window.
Figure 1-8. You can drag a toolbar to a more convenient location. To dock it again, drag it back to the top, bottom, or side of the Visio window.
Tip
To close any Visio window, right-click its title bar, and then click Close.

Working in the Visio Drawing Page

The quickest way to fill a blank drawing page is to drag shapes onto it. When you start a diagram with a template, Visio typically opens several stencils, which Visio docks on the left side of the screen. To bring a stencil to the top of the stack, click its name. The stencil that was on top is minimized, as Figure 1-9 shows. You can drag an individual stencil window to a new location on the screen, or you can drag the entire Shapes pane and dock it in a new location, as Figure 1-10 shows. To move the stencil back to its original position, drag the Shapes title bar to the left side of the window; Visio automatically docks it against the side of the window. Rather than drag a stencil, you can right-click the Shapes title bar, and then click Float Window. You can resize a floating stencil by dragging a side or corner.

Figure 1-9. To display a stencil, click its name on the stencil window's title bar.
Figure 1-9. To display a stencil, click its name on the stencil window's title bar.
Figure 1-10. Dock your stencils in a new position by dragging the Shapes title bar to the top, side, or bottom of the Visio widow.
Figure 1-10. Dock your stencils in a new position by dragging the Shapes title bar to the top, side, or bottom of the Visio widow.

Stencils typically display three master shapes across and several down, although you can adjust this arrangement. The term master shape (or master) is used to differentiate between the shape as it appears in a stencil and the copy of it that you drag onto your page. You can resize the Shapes area to display more or fewer master shapes at a time: point to the gray area between the Shapes area and the drawing page. The pointer becomes a two-headed arrow, indicating that you can drag the window's right border to resize it.

Troubleshooting

The Shapes window split the stencil windows in two.

Because Visio can dock a window anywhere you drag it, if you inadvertently drag a stencil by its name, it can end up below the other stencils in a separate pane. To dock the stencil with the others, drag it into the middle of another stencil. At lower screen resolutions (such as 800×600), you may find it easier to use a two-step process: Drag the stencil into the middle of the drawing page, and then release the mouse button so that the stencil floats. Then, point to its title bar, drag it back into the Shapes window, and drop it in the middle of the open stencil.

Panning and Zooming

To get a good look at a diagram, you can zoom in close or zoom out to see the entire page. When you start a new diagram, Visio displays the full page. If you look at the Zoom box on the Formatting toolbar, you'll see the percentage of zoom. To get a close-up view, click the drop-down arrow on the Zoom box, and then choose a larger percentage. At 100% view, shapes appear on the screen at the same size they appear when printed.

When you're working in a large diagram, you can use the Pan & Zoom window to see where you are in the big picture, as Figure 1-11 shows. To display this window, click View, Pan & Zoom Window. Visio docks the window alongside the drawing page, but you can move it to a location or dock it with the stencils as you can do with any window in Visio. In the Pan & Zoom window, a red selection box highlights the area currently displayed on the drawing page. You can

  • Drag a side or corner of the red box to resize it, thereby changing the level of zoom on the drawing page.
  • Drag to create a new selection box in the Pan & Zoom window, which effectively displays a new area of the drawing page and zooms in.
Figure 1-11. In a large diagram, you can get a close-up view of the drawing page by zooming and maintain a bird's-eye view in the Pan & Zoom window.
Figure 1-11. In a large diagram, you can get a close-up view of the drawing page by zooming and maintain a bird's-eye view in the Pan & Zoom window.
Tip
Use the AutoHide icon (which looks like a pushpin) to allow windows to tuck out of sight when not in use. When you point to the window, it scrolls open again.

Although the Pan & Zoom window is great for providing the big picture, you can also use keyboard shortcuts for moving around a drawing page and quickly zooming in and out as Table 1-2 shows.

Table 1-2. Keyboard Shortcuts for Panning and Zooming

Shortcut | Effect
Press Shift+Ctrl+left mouse button | Zooms in
Press Shift+Ctrl+right mouse button | Zooms out
Press Shift+Ctrl+drag with the left mouse button | Zooms in on a selected area
Press Shift+Ctrl+drag with the right mouse button | Pans the drawing page
Note
In Visio, the zoom level at which you view and work on a drawing is independent of the scale you set for a drawing page. Whatever your drawing scale, you may still need to zoom in on a portion of a drawing to move shapes exactly or do other precise work. For example, you can change the magnification from 50% to 200%.

Viewing Shapes and Pages in the Drawing Explorer

Another useful tool in Visio that provides an alternative view of your diagram is the Drawing Explorer, as Figure 1-12 shows. For some diagram types, it helps to see a hierarchical list of shapes and other objects sorted by page. The Drawing Explorer provides this view. To display it, click View, Drawing Explorer Window. In the Drawing Explorer, you can add, delete, and edit items in your drawing. You can even use it to locate shapes—when you double-click a shape that's listed in the Drawing Explorer, Visio also selects it on the drawing page, making it more visible.

Figure 1-12. The Drawing Explorer provides a hierarchical view of the shapes, pages, and other objects in your diagram.
Figure 1-12. The Drawing Explorer provides a hierarchical view of the shapes, pages, and other objects in your diagram.

You can display the Drawing Explorer for any diagram type in Visio. However, some solutions include their own explorer windows for organizing information on the page. For example, a piping and instrumentation diagram includes a Component Explorer that works specifically with that solution's shapes. These special-purpose explorer windows are described elsewhere in this book.

Tip - Play Sounds in Visio

If you find audible feedback amusing, you can have a sound play when a Visio window, such as the Drawing Explorer or Pan & Zoom window, opens and closes. To do this, use the Sounds And Multimedia (Windows 2000) or Sounds (Windows 98) option in the Windows Control Panel. In the Sound Events or Events box, select Restore Up or Restore Down under Windows. Click the drop-down arrow on the Name box, select a sound, and then click OK.

Merging Windows

If you work with drawing types that require the use of several view windows, consider taking advantage of a great new feature. You can merge windows, such as the Drawing Explorer and Pan & Zoom windows, which means to tuck one window inside another. Visio displays page tabs so that you can switch between windows, as Figure 1-13 shows. To merge windows, drag a window by its title bar into the center of a docked window. You can merge any anchored window, which includes the Custom Properties window, Drawing Explorer window, Pan & Zoom window, Size & Position window, and some template-specific windows. To display any of these windows, choose a command from the View menu.

Figure 1-13. To conserve screen real estate, you can merge docked windows.
Figure 1-13. To conserve screen real estate, you can merge docked windows.
Tip - Dock Windows

The Shapes window where stencils are stored is a handy location for docking other windows while you work. For example, point to the title bar of a window, such as the Pan & Zoom window discussed later. Drag to the Shapes window, and then release the mouse. Visio arranges the window above or below the stencils so that all the tools you work with appear together.


Finding the Information You Need

As you work in Visio, you can display detailed task information in Help and find answers to specific questions by using the Answer Wizard. On the menu bar you can type a question in the Ask A Question box, as Figure 1-14 shows. When you press the Enter key, Visio lists possible topics of interest. When you click a topic, the Help window opens. You can dock it alongside the drawing page or float it on top for greater readability.

Figure 1-14. Type your question in the Ask A Question box on the menu bar and press Enter to start the Answer Wizard.
Figure 1-14. Type your question in the Ask A Question box on the menu bar and press Enter to start the Answer Wizard.

Using Online Help

There are several ways to display the Help window without going through the Answer Wizard. You can

  • Choose Help, Microsoft Visio Help, and then click the Contents tab to list topics, as Figure 1-15 shows.
  • Click the Help button on the Standard toolbar.
  • Press the F1 key.
Figure 1-15. You can dock or float the Visio Help window with the Auto Tile button. Use the tabs to hide or show the contents, Answer Wizard, and Index.
Figure 1-15. You can dock or float the Visio Help window with the Auto Tile button. Use the tabs to hide or show the contents, Answer Wizard, and Index.

You can locate information on the Index tab by searching for a keyword, or you can use the table of contents on the Contents tab to scan topics. The Answer Wizard tab provides another way to type your question and see a list of potentially related topics.

Template Help

For each template, you can get help on the most efficient way to draw, the best way to use and combine shapes, how to perform specific actions using shape and page shortcut menus, how and when to access wizards that automate tasks, and more. To get help on a particular template, press F1, click Contents, and click the plus (+) sign next to Drawing Types to expand the list. Expand the drawing type you want, and then choose the type and name of the template you want.

Note
If the Contents tab is not visible in the Microsoft Visio Help pane, click the Show button.
Tip
To display generic information about how to use shapes, right-click a shape, and then choose Help.

Dialog Box Help

Another quick way to find answers when you're working in a particular dialog box is to click its Help button, as Figure 1-16 shows. The Help pane opens with context-sensitive help—that is, details about each option in the dialog box.

Figure 1-16. When you choose a command that displays a dialog box, you can find out what each option does by clicking the Help button.
Figure 1-16. When you choose a command that displays a dialog box, you can find out what each option does by clicking the Help button.

Sources of Other Information

Questions frequently arise while you work. If the Answer Wizard doesn't have the answer, try the following Web resources:

  • For the latest Visio shapes, choose Find Shape on the File menu. It can search a Web-based database of Visio shapes and locate what you need.
  • For tips about working efficiently in Visio, see the Microsoft Office Web site (http://office.microsoft.com).
  • For articles about known issues and technical problems, search the Knowledge Base (http://search.microsoft.com).

Information for Network Professionals

If you're using Visio Professional, the Visio Network Center Web site links you to more information about network diagramming tools. Microsoft very much wants Visio Professional users to know about the Microsoft Visio Enterprise Network Tools add-on, which includes shapes and solutions that ease network documentation. On the Visio Network Center site, you'll find new tools, up-to-date network equipment shapes, and advanced network solutions.

Information for Visio Developers

Visio is a graphical development platform that includes Visual Basic for Applications 6.3 (VBA). For example, corporations can build business-integrated applications for asset tracking, sales force automation, automated scheduling, data visualization, and so on by integrating Visio with their systems. Although this book is not specifically intended for the developer audience, technical information about Visio development tasks appears in several places in the product and on the Web:

  • Programmers and others who want to extend Visio can use the Developer Reference. To display it, click Help, Developer Reference. The Reference includes a complete Automation and ShapeSheet reference and information about programming with Visio.
  • Developing Microsoft Visio Solutions is the complete guide to creating shapes and programming with Visio. It's available from Microsoft Press.
  • The Visio Developer Center (http://msdn.microsoft.com/visio) provides technical articles, code samples, and more.

Troubleshooting

Shape names are not readable on stencils.

If you display only the shape icons, no text labels appear. To turn on your text labels again, click the tiny green icon in the upper left corner of the stencil's title bar. In the shortcut menu that appears, click Icons And Names.

If the problem is that the text is just too small to be read easily, you can try spacing the icons apart more or changing the colors to improve the contrast. The font size of the label itself can't be changed. Click Tools, Options, and then click the View tab. Try adjusting the options under Stencil Spacing as well as the Stencil Text and Stencil Background options under Color Settings.


Opening Visio Documents

In Visio, you can open diagrams, stencils, templates, and workspace files. Each is represented by a different file extension:

  • VSD is a Visio drawing file.
  • VSS is a Visio stencil file.
  • VST is a Visio template file.
  • VSW is a Visio workspace file.

Most of the time, you use the Open command or toolbar button to open a drawing file (.vsd). This section focuses on different ways to open diagrams.

For details about opening and saving Visio files in XML format, see "Visio and XML File Formats".

Opening an Existing Diagram

Now that Visio includes the same Open dialog box as Microsoft Office (see Figure 1-17), with the Places bar of shortcuts, you can quickly locate frequently used folders and documents. Not only can Visio 2002 open documents created in Visio 2000, Visio 2000 can open diagrams created in Visio 2002. Visio 2002 can open diagrams created in any earlier version of Visio.

Figure 1-17. Visio includes the same Open dialog box as other Microsoft Office XP programs.
Figure 1-17. Visio includes the same Open dialog box as other Microsoft Office XP programs.

To open an existing drawing file:

  1. Click the Open button on the Standard toolbar to display the Open dialog box. You can instead choose File, Open or press Ctrl+O.
  2. In the Look In list, open the folder that contains the file or files you want to open. Visio displays the folder's contents.
  3. Click a file to select it. To open more than one drawing file, press Ctrl and then click the files you want.
  4. Click Open.

Opening a Recently Used Diagram

The quick way to find a diagram you worked on recently is to look on the File menu, which lists the most recently opened diagrams at the bottom of the menu. Click the file name to open the diagram. You can also use the New Drawing task pane to locate recently opened files. This is a good technique to use when you're starting Visio, because the Choose Drawing Type pane appears with the New Drawing task pane. If you're working in Visio and want to display it, choose File, New, Choose Drawing Type. In the New Drawing task pane, you'll see the diagrams you've worked on under the Open A Drawing heading. If you don't see the drawing you want listed, click More Drawings. Visio displays the Open dialog box, so you can locate the file you want.

Opening Another Visio File Type

Besides drawing files, Visio can open stencils, templates, workspaces, and files in other formats as well. Choose File, Open. The key is to use the Files Of Type drop-down list that appears at the bottom of the Open dialog box. Click the drop-down arrow to display a list of the types of files that Visio can open. Select a file format. Then, in the Look In list, open the folder that contains the file you want to open. Only the files of the type you selected are displayed, making it easy to locate and select the one you want. Then click Open.

Opening a Sample File

Visio includes a sample of every type of drawing and diagram that you can create. You can use the sample files merely as inspiration, or edit them and save them as a new diagram. To browse the list of sample files, click File, New, Browse Sample Drawings. Visio displays a dialog box that looks just like the Open dialog box, except that it displays sample file folders, as Figure 1-18 shows. Double-click a folder to display the samples for that diagram type. For example, double-click Flowchart to display the list of sample flowchart diagrams.

Figure 1-18. Visio includes a sample drawing file for many diagram types.
Figure 1-18. Visio includes a sample drawing file for many diagram types.
Tip
By default, Visio stores its sample files in C:\Program Files\Microsoft Office\Visio10 \1033\Samples.

Opening a New Drawing File Without a Template

You can open a new Visio drawing file that's not based on a template. Visio creates a new diagram with a blank drawing page and the default page settings for unscaled drawings. It's like starting with a fresh slate. No stencils are opened, but you can add them later. To do this, click Ctrl+N, or choose File, New, New Drawing.

Opening Stencils

When you want to work with more shapes, you can open additional stencils. There's a practical limit to the number of stencils you can open, although it depends on your screen resolution. The screen can become pretty crowded with more than about seven stencils, and it gets a little tougher to find the particular shape you want. However, you can open as many stencils as you need. The easiest way is to use the Open Stencil button on the Standard toolbar. It does one of two things:

  • If you click the button itself, the Open Stencil dialog box appears.
  • If you click the drop-down arrow on the button, a menu of diagram types appears, and you can point to a type to display its stencils, as Figure 1-19 shows.
Figure 1-19. The quickest way to open another stencil is with the Open Stencil button on the Standard toolbar.
Figure 1-19. The quickest way to open another stencil is with the Open Stencil button on the Standard toolbar.

If you prefer working with menus, choose File, Stencils, Open Stencil to display the Open Stencil dialog box, where you can locate any stencil, including ones you create.

Inside Out
If you create your own stencils, they will appear on Visio's stencil lists in the Open Stencil button and dialog box if you save them in the right folder. Visio automatically looks for stencil (.vss) files in the C:\Program Files\Microsoft Office\Visio10\1033 \Solutions folder and its subfolders.

For details about creating stencils, see "Saving Customized Shapes as Masters". For details about opening stencils for editing, see "Opening Stencil (.vss) Files".

Opening Older Versions of Microsoft Visio Files

You can open files created in any previous version of Microsoft Visio Standard, Visio Professional, Visio Technical, or Visio Enterprise, including Visio 1, 2, 3, 4.x, 5.x, or 2000. To do this, choose File, Open, locate the drawing file you want to open, and then click Open.

newfeature! Another great new feature is that any drawing file you create with Visio 2002 can be opened by other Visio users—regardless of the version of Visio they have. They may not be able to see every drawing element, however. For example, Visio 5 and earlier does not include many of the windows on the View menu, such as the Pan & Zoom window.

Tip
If you use Windows Explorer to locate a Visio drawing file (.vsd) created in an older version of the product, you can double-click the file name. Visio 2002 automatically opens with the old drawing.

Troubleshooting

Opening a Visio drawing file causes a message about macros to appear.

When you open a drawing file that includes a VBA macro or other programming code, Visio displays a message to warn you about its contents, as Figure 1-20 shows. Usually the macros are needed to enable interactive features of the drawing. This message is a new safeguard feature of Visio. If you know that the drawing file came from a reputable source, click Enable Macros. Visio probably requires the macro to run the built-in shape intelligence.

Figure 1-20. If you open a Visio drawing file that includes a built-in macro, as many Visio drawings and templates do, this message appears.
Figure 1-20. If you open a Visio drawing file that includes a built-in macro, as many Visio drawings and templates do, this message appears.

If you frequently open drawing files created in older versions of Visio, you may want to disable the message. This requires lowering your security settings. To do this, click Tools, Macros, Security, and then select the Low security option.

Searching for a File to Open

The task pane includes a powerful search tool that you can use to find the files or folders you need without leaving your Visio diagram. You can locate text in a document and find files or folders, regardless of where they are stored—your local hard disk, a network folder, or in Microsoft Outlook. Like many Web search engines, the task pane includes a Basic Search and an Advanced Search. To display the task pane, click View, Task Pane. The task pane's Basic Search options appear as Figure 1-21 shows.

Figure 1-21. The task pane (View, Task Pane) helps you locate documents based on the text they contain.
Figure 1-21. The task pane (View, Task Pane) helps you locate documents based on the text they contain.
Tip - Switch Between New Drawing and Search Task Pane

If you display the task pane and the New Drawing options appear, click the drop-down arrow on the title bar, and then select Search. This is a fast way to switch between options for searching and opening drawings.

You can do the following:

  • In the Search Text box, type one or more words—text in the document, keywords, or other file properties. Use an asterisk character (*) to replace groups of characters and a question mark (?) to replace a single character. Click Search Tips for help.
Tip
The more words you type in the Search Text box, the more specific your search results will be.
  • In the Search In box, tell Visio where to look. If you know which folder, you can type it in the Search In box. Otherwise, click a plus sign (+) to expand the list, and click to place a check mark beside the folder at the highest level you want to search. You can click a check box several times—with each click, the selection changes. A second click selects a folder and all folders within it. A third click cancels the top selection but retains the folders. A fourth click cancels the entire selection, folders and all.
  • In the Results Should Be box, you can narrow the scope of the search to locate only files of a particular type.

When you click the Search button, Visio begins the hunt and displays the Search Results. To return to the Basic Search task pane, click the Modify Button. To refine the search criteria, click the Advanced Search option at the bottom of the Basic Search pane.

Opening a File in a Document Management System

If you work with a document management system (DMS) that supports the Open Document Management API (ODMA) standard, you can retrieve and store Visio drawings and diagrams with it. If Visio detects the presence of an ODMA 1.5–compliant system on your computer, you can choose File, Open to open your drawing file, and the DMS Open dialog box appears instead of the Open dialog box. If you use another method of opening your file, such as pressing Ctrl+O, you won't be able to save to the document management system. If the DMS Open dialog box does not appear, you may need to register Visio with your document management system. Refer to the documentation that came with your document management system.


An Office XP Overview

A Rundown on Office XP

The Microsoft Office XP suite provides more applications and utility programs than ever before. Which ones you have depends upon which edition of Office XP you own or which individual Office applications you've obtained. This book covers all the major Office XP applications:

  • Microsoft Word (Part 3)
  • Microsoft Excel (Part 4)
  • Microsoft PowerPoint (Part 5)
  • Microsoft Outlook (Part 6)
  • Microsoft FrontPage (Part 7)
  • Microsoft Access (Part 8)
  • Microsoft Publisher (Part 9)

The book also covers many of the valuable utility programs and add-ons that are included with Office XP (or are available on the Web) and that help you work with the main applications:

  • Office Shortcut Bar (Chapter 4)
  • newfeature! Clip Organizer (Chapter 6). See Figure 1-1.
  • Microsoft Graph (Chapter 6)
  • Microsoft Equation (Chapter 6)
  • Save My Settings Wizard (Chapter 9)
  • Office Resource Kit, including the Custom Installation Wizard (Chapter 2)
    Figure 1-1. You can run the new Clip Organizer program in its own window, shown here, or through the new Insert Clip Art task pane.
    Figure 1-1. You can run the new Clip Organizer program in its own window, shown here, or through the new Insert Clip Art task pane.

Even if you don't have one or more of the applications covered in this book, you might want to read some of the information about these applications to help you decide whether to add an Office program to your software collection or whether you're better off using the applications you already have.

Advantages of the Office XP Suite

Obtaining and installing the Office XP application suite, rather than acquiring individual applications here and there, isn't just a way to economize by buying programs "cheaper by the dozen." The real advantages of a software suite such as Office XP lie in the common user interface and the application integration features.

In Office XP, the individual applications share more common features than in any previous Office version. An obvious advantage of a common user interface is that once you learn one application, it's much easier to learn another. Also, as you switch between applications, you won't have to switch working modes quite so radically. And, perhaps most important, a common user interface frees your focus from the individual applications and their idiosyncrasies and lets you concentrate on the documents you're creating. The following are examples of important common features in the Office XP suite:

  • The menus, toolbars, shortcut keys, and the methods for customizing these features.
  • The common dialog boxes (notably, the Open and Save As dialog boxes), with shared features such as the Search command that now lets you find either files or Outlook items.
  • The task panes (described later in this chapter). See Figure 1-2.
    Figure 1-2. The new Search task pane, which is available in most Office applications, lets you locate either disk files or Outlook items.
    Figure 1-2. The new Search task pane, which is available in most Office applications, lets you locate either disk files or Outlook items.
  • The methods for displaying and setting document properties.
  • The speech and handwriting interfaces.
  • The drawing features (Drawing toolbar, AutoShapes, Diagrams, WordArt, and others). See Figure 1-3.
    Figure 1-3. The new Diagram Gallery dialog box lets you quickly insert a variety of ready-made conceptual drawings.
    Figure 1-3. The new Diagram Gallery dialog box lets you quickly insert a variety of ready-made conceptual drawings.
  • The proofing tools (Spelling, Thesaurus, AutoCorrect, and others).
  • The help interface and the Detect And Repair command.
  • The Visual Basic for Applications (VBA) programming features.
  • The ability to store and share documents on SharePoint team Web sites.

The Office XP applications are also more tightly integrated than ever. Application integration extends the usefulness of the individual applications. It lets you combine applications in a synergistic way to solve more complex problems and to easily accomplish otherwise difficult tasks. The following are examples of application integration features available in Office XP:

  • The Office Shortcut Bar, as well as the New Office Document and Open Office Document commands on the Start menu in Windows, which let you create or open any type of Office document
  • The ability of Office applications to import and export each other's documents (using the Open and Save As dialog boxes, as well as special purpose commands for importing and exporting documents or data)
  • The capability of using data stored in Outlook or Access when creating mail-merge documents in Word
  • Commands for linking and embedding data from several Office applications in a single compound document
  • VBA, the common programming language of the Office applications and the most powerful way to create solutions using multiple Office applications


An Office XP Map

If you're not sure where to start with Office, you can use Table 1-1 to select the best Office application to use for creating the type of document you want or for performing the task you need to complete.

NOTE
For a more detailed rundown on an Office XP application, see the first chapter in the part of the book that covers that application.

Table 1-1. The Best Office XP Application to Use for Performing Specific Tasks

Office XP Application to Use Task

Word

  • Create general printed or online documents of all kinds—for example, memos, letters, faxes, reports, contracts, résumés, manuals, theses, and books.
  • Enter and organize research notes, outlines, and other types of free-form text information.
  • Generate form letters, envelopes, labels, and other mail-merge documents (see Figure 1-4).
  • Print individual labels and envelopes.
  • Create general-purpose, relatively simple Web pages, which can include almost any Word document element, plus movies, sounds, forms, frames, visual themes, navigation bars, and components for accessing information on a SharePoint team Web site. Use templates to create personal Web pages and other types of pages or use the Web Page Wizard to create simple Web sites.

Excel

  • Save, organize, calculate, analyze, and chart numeric business or personal data in a spreadsheet (row and column) format. For example, balance checking accounts, prepare invoices, plan budgets, trackorders, or maintain general accounting ledgers.
  • Store relatively simple text or numeric data in lists that organize the information into records (rows) and fields (columns)—for example, a product inventory or descriptions of members of your ski racing team. Sort, find, filter, automatically fill, summarize, group, outline, or subtotal data. Display data in varying combinations using pivot tables or pivot charts.
  • Publish static or interactive spreadsheets, charts, or pivot tables, for displaying numeric, text, or graphic information on the Web. Publish forms on the Web for collecting data in lists or other databases.

PowerPoint

  • Create multimedia presentations consisting of sets of slides to teach, sell, communicate, or persuade. Include text, graphics, animations, sound, and video in your presentations. Present multimedia information using 35 mm slides, transparencies for overhead projectors, speaker notes, printed handouts, or live slide shows on a computer or computer projector.
  • Publish presentations on the Web that consist of a series of multimedia slides displaying text, graphics, animations, sounds, or videos.

Outlook

  • Send, receive, and organize e-mail messages. Exchange instant Internet messages.
  • Store and manage personal information (appointments, names and addresses, to-do lists, journal entries, or free-form notes).
  • Communicate and coordinate with members of your workgroup (schedule meetings, manage group projects, and share information and files).
  • Access files on local or network disks and explore Web sites.
  • Publish snapshots of your calendar on the Web.

FrontPage

  • Create entire Web sites using templates or wizards—such as a site for establishing a corporate presence, displaying personal information, conducting an online discussion, managing a project, or accessing shared information stored on a SharePoint team Web site (see Figure 1-5). Use visual themes to apply consistent formatting to all pages in your site.
  • Manage your Web site (maintain files and folders, display reports, create and update hyperlinks, track tasks, publish your site, or control the source in workgroups).
  • Create a Web page quickly using a template or wizard (for example, a page containing a bibliography, a feedback form, or a table of contents).
  • Create or edit a Web page using a full-featured HTML (Hypertext Markup Language) editor, which supports all standard Web page elements and provides ready-to-use Web-page components (date and time stamps, comments, hover buttons and other dynamic effects, forms for searching the site, spreadsheets and charts, hit counters, galleries of photos, included files, link bars, tables of contents, site usage statistics, views of information stored on a SharePoint team Web site, and controls that display information from Web sites such as MSN).

Access

  • Store, organize, select, and present data in a relational database, which allows you to easily manage large amounts of complex or interrelated data and to divide data into separate, related tables to maximize storage efficiency.
  • Publish an interactive form on an intranet that allows users to view or update information from a database.

Publisher

  • Use wizards to create brochures, flyers, signs, greeting cards, business cards, menus, catalogs, newsletters, and other relatively short documents that have precise page layouts integrating text and graphics.
  • Create coordinated sets of publications (business cards, letterheads, envelopes, fax cover sheets, and so on).
  • Use wizards to create graphical Web pages.
Figure 1-4. Word's new Mail Merge task pane makes it easy to create and print form letters, envelopes, labels, and other mail-merge documents.
Figure 1-4. Word's new Mail Merge task pane makes it easy to create and print form letters, envelopes, labels, and other mail-merge documents.
Figure 1-5. In FrontPage you can create a new team Web site on a Web server running SharePoint Team Services from Microsoft. This figure shows the home page of a newly created team site.
Figure 1-5. In FrontPage you can create a new team Web site on a Web server running SharePoint Team Services from Microsoft. This figure shows the home page of a newly created team site.


What's New in Office XP

The following sections briefly describe many of the new features and enhancements found in Office XP. (Office XP has so many new features and enhancements that it would be difficult to list them all!)

New Common Office XP Features

Each of the following new features is available in most—or many—of the main Office XP applications.

  • Task panes In Office applications you can now carry out certain operations or choose selected options using a new alternative to a dialog box known as a task pane. A task pane is a Web-style command area that you can dock along the right or left edge of the window or float anywhere on the screen. Most Office applications provide the following common task panes: New Document (the name varies with the specific application), Clipboard, and Search. (For examples of task panes, see Figures 1-2 and 1-4.)
  • Search feature Office XP includes a new search feature that you can use to locate files on local disks, network drives, or Web sites or to find items in Outlook folders. You can run the search feature in the Search task pane (see Figure 1-2), or in a dialog box that you display from the Open or Open Office Document dialog box.
  • Document recovery Office XP provides many new features to help you recover your data in the event of a program crash. For example, Office applications attempt to save your document when a crash occurs, and, on restarting, provide a Document Recovery task pane to help you restore your document. Also, you can use the new Office Application Recovery utility to break into a hung application so it can save your data. And you can use the Open And Repair option in the Open dialog box to attempt to repair a corrupted document.
  • Speech recognition In Office XP applications you can now dictate text rather than type it, and you can issue basic commands by speaking them rather than by using the mouse or keyboard.
  • Handwriting interface Office XP applications now let you enter text into a document using an electronic tablet and pen or (with difficulty) an ordinary mouse. You can either insert handwritten characters (such as your signature), or you can have Office recognize your handwritten characters and convert them to regular text.
  • Smart tags Office XP applications can now recognize a wide range of different data types entered into a document (such as names, dates, addresses, and stock ticker symbols). The application converts each recognized piece of data into a smart tag, and you can then use a menu attached to the smart tag to perform useful actions on that data, automatically invoking the required Windows program.
  • AutoCorrect Options button After the Office AutoCorrect feature makes a change, you can modify the correction using the new AutoCorrect Options button.
  • Paste Options button When you paste data into an Office XP document, a Paste Options button appears, allowing you to select the desired format of the pasted data and to switch among different formats to determine the one you want.
  • XML (Extensible Markup Language) support Excel and Access 2002 can now import and export data from and to XML documents. Also, you can have FrontPage 2002 apply XML formatting rules when generating the HTML source for the Web pages you create.
  • Diagrams In Office XP applications you can now get a head start in building a conceptual drawing—such as an organization chart or a Venn diagram—by inserting a ready-made Office diagram. (See Figure 1-3.)
  • Windows in Taskbar option You can now display documents in top-level windows with buttons in the Windows Taskbar (as in Office 2000), or you can display them in child windows within a single top-level application window without displaying a toolbar button for each document window (as in Office 97 and earlier).
  • New From Existing command You can now create a new document based on an existing document as an alternative to using a template.
  • SharePoint access In Office XP applications you can now open or save documents stored on a SharePoint team Web site, you can participate in online discussions hosted by the site, and in some types of Office documents you can insert Web components that allow you to view and modify shared information stored on a team site. (A team Web site is hosted by a Web server that runs SharePoint Team Services, and it provides collaboration features that allow workgroups to share documents and exchange information. See Figure 1-5.)

New Word Features

  • New formatting features Word 2002 now saves and lets you reapply directly assigned formatting features as an alternative to using styles. In addition to character and paragraph styles, Word provides table and list styles for applying predefined formatting features to tables and to multilevel lists. To find out what formatting and style (or styles) have been applied to characters in your document, you can use the new Reveal Formatting task pane. To remove all formatting from text, you can use the new Clear Formatting command. To find text that's inconsistently formatted with the rest of the document, you can use Word's new formatting consistency checker. To select all text that has the same style or saved format as the current selection, you can use the new Select All command. And you can simultaneously select multiple blocks of text or graphics in a document so that you can format or edit all of them at once.
  • Change tracking The change tracking feature has been completely revamped—for example, you can have Word mark changes using margin balloons without disturbing the line and page breaks in the document.
  • Comments In Word 2002, comments have also been extensively redesigned—for instance, you can have Word display comment text in margin balloons, making it easy to insert, view, or edit the comment text.
  • Document security Document security has been enhanced—for example, the Options dialog box provides a new Security tab, and you can attach a digital signature to a document.
  • Document statistics You can display the number of words, characters, lines, pages, or paragraphs in the current document using the new Word Count toolbar.
  • Text translation You can use Word's new Translate task pane to translate into a different language either a word, or—by means of a translation service on the Web—a phrase, a block of text, or an entire document.
  • Watermarks Word's new Printed Watermark command makes it easy to add a document watermark, which consists of faint text or graphics displayed across every page in the document or in a document section.
  • Booklet printing Word provides new page setup and printing options that make it easy to directly print a booklet or even a book.
  • Mail Merge Wizard Word's new Mail Merge Wizard, which runs in the Mail Merge task pane, makes it easy to create form letters, envelopes, labels and other mail-merge documents. (See Figure 1-4.)
  • New Web page formats Word now lets you save a Web page in the Web Archive (*.mht, *.mhtml) format, which saves everything in a single Web archive file. You can also filter a Web page when you save it, which generates a smaller and "cleaner" HTML file by preserving only the essential document information (but with the possible loss of document features).

New Excel Features

  • Unlocking data A number of new tools make it easier to find, analyze, and publish data associated with worksheets in Excel 2002. Web queries make it easier to link to data on the Web. Web Page AutoRepublish automatically keeps Web pages in sync every time you save your document. Copy Paste Web Query automatically links to data on the Web when you paste it from a Web page. Import Data allows you to easily find and share data sources.
  • Improved pivot tables Pivot tables have been improved with drop-down menus and other user interface enhancements. The automatic GetPivotData formula streamlines the analysis of pivot table data.
  • Access to more data Excel 2002 works with more data types, including common data sources on the Web. XML is supported as a data interchange format, and worksheets can be linked directly to XML data on the Web. The new real-time data (RTD) function brings real-time data into Excel for analysis.
  • Command and feature enhancements Numerous menu command and product feature enhancements make Excel even easier to use in fundamental areas, including link management, Find and Replace searches, hyperlink navigation, sorting, drawing borders, inserting international number formats, editing cells vertically, error checking, and customizing headers and footers with graphics and additional information. The IntelliPrint feature eliminates the printing of blank pages, an enhancement designed to conserve your printing and paper resources.

New PowerPoint Features

  • Collaboration Several tools make it easier to edit and review PowerPoint 2002 presentations in workgroup environments. You can now save presentations with password protection, so that reviewers can view presentations in PowerPoint but not edit or save them. Web broadcasting is now easier to use. Authors can now attach digital signatures to their presentations to increase security and reviewer confidence. Presentation review cycles in workgroups have been made easier through routing and reconciliation features, which manage change requests from multiple reviewers. Comments have been revised so that in addition to allowing reviewers the chance to insert "hidden" notes in presentations, they can be compared to one another, merged together, and printed in a new way.
  • Animation You can now apply a combination of animation and transition schemes to your whole presentation at once—a significant time saver. New slide transition effects include Comb, Fade Smoothly, Newsflash, Push, Shape, Wedge, and Wheel. Custom animation effects are easier and more impressive now that PowerPoint lets you control exit animations, path animations, and timed/simultaneous animations.
  • Everyday tasks made easy The Copy and Paste commands are better able to handle inserting different content types and a larger volume of information. Print Preview allows you to determine how a presentation prints and lets you make fine-tuning adjustments. Slide formatting is easier with "one-click" formatting. You can apply more than one design template to the same presentation. Thumbnail views of your slides are now available in Normal View.

New Outlook Features

  • Single configuration Outlook 2002 no longer has the separate Corporate Or Workgroup and Internet Only configurations. The features of both these configurations are combined in a unified configuration.
  • Enhanced Preview pane If you select an item in the Calendar, Contacts, or Journal folder, the Preview pane now displays the item within its form (that is, within the form used to display the item when you open it).
  • Outlook item search You can search for Outlook items, as well as disk files, by using the new Search task pane in Office applications. (See Figure 1-2.)
  • Account groups If you have more than one e-mail account, you can now set up account groups to control exactly which accounts Outlook uses to send and receive e-mail when you initiate a send and receive operation and also to have Outlook automatically send and receive e-mail at fixed intervals using specific accounts.
  • Easier management of e-mail headers Outlook provides an easier interface for downloading and screening e-mail message headers before you download the full content of your messages.
  • Mailbox Cleanup You can use the new Mailbox Cleanup dialog box to weed out messages when your Inbox starts growing out of control.
  • Appointment color coding You can now tag your appointments using colors—for example, red for an important appointment, blue for a business appointment, green for a personal appointment, and so on.
  • Alternative meeting times When you use Outlook to plan a meeting, an attendee can now reply by proposing a new meeting time, rather than simply accepting or declining the invitation.
  • Enhanced meeting planner You can now consult the meeting planner whenever the Calendar folder is open, without actually scheduling a meeting.
  • Unified Reminders dialog box All pending appointment reminders are now displayed in a single Reminders dialog box, so you don't have to view and close a separate dialog box for each one.
  • Instant Messaging You can now use Instant Messaging to communicate from Outlook in real time.
  • Address Bar You can use the new Address Bar to explore Web pages within the Outlook window.

New FrontPage Features

  • Customization of SharePoint Web sites You can now create or customize a SharePoint team Web site. You can add new custom document libraries, surveys, and other types of lists to a team site. You can view team site usage statistics. You can add a Document Library View or List View Web component to a page, which allows you to view the contents of a document library or a list on a team site. And you can create a custom form for adding, editing, or displaying items in a document library or other type of team site list. (See Figure 1-5.)
  • Navigation pane You can view a web's navigation structure in Page view by opening the new Navigation pane.
  • Report publishing You can now copy a web report to a Web page, so that you can publish the report on the Web.
  • Enhanced Web publishing The Web publishing feature has been completely revamped. For instance, you can publish individual files that belong to a web. And when you publish, the Web Publish dialog box letsyou select exactly which files to publish and enables you to manage files in the local web as well as files on the destination server (you can cut, copy, paste, rename, or delete files, or copy files between the source and the destination).
  • Tabs in Page view You can now quickly switch between pages opened in Page view by clicking the tabs at the top of the window.
  • Language formatting You can now mark foreign text contained in a Web page so that Outlook uses the correct dictionary for checking its spelling and looking up synonyms.
  • Added graphics features You can now quickly add and arrange a collection of images by inserting a Photo Gallery Web component. You can create drawings within FrontPage using AutoShapes and the Drawing toolbar. And you can add decorative text by inserting a WordArt object.
  • Automatic table fill If you've added text to one table cell, you can now have FrontPage automatically copy that text to other cells.
  • Enhanced shared borders You can now assign a separate background color or picture to an individual shared border as well as to the main part of a page.
  • Collapsible outlines You can now convert a simple list to a multilevel outline that the page visitor can collapse or expand.
  • Inline frames As an alternative to creating a frames page to view multiple pages, you can now insert an inline frame, which is a rectangular element that displays another page and lets you scroll through it.
  • New Web components FrontPage provides new Web components, including new types of custom link bars, components that let you display information from the MSN or MSNBC Web sites, and components for SharePoint team Web sites (mentioned previously in this list). You can also download additional Web components from the Web.

New Access Features

  • New database format Access 2002 provides a new database file format that offers better performance for larger databases. You can open and save databases in either the old format or the new one, and you can easily convert databases between formats.
  • Enhanced spelling checker You can modify the way the spelling checker works by using the new Spelling tab in the Options dialog box.
  • Convert objects to data access pages You can now convert a table, query, form, or report to a data access page.
  • XML support You can now import or export data from or to XML documents.

New Publisher Features

  • Prepress preparation Publisher 2002 offers enhanced commercial printing functionality, including support for up to 12 "spot colors" in a single publication and the ability to combine process and spot colors in the same publication. Publisher also includes a new version of the EPS (Encapsulated PostScript) filter, which provides improved handling and previews of text, as well as improved handling of named colors to properly separate EPS graphics in spot-color publications.
  • Common features and improvements Font schemes make it easy to give your publication a new look. Choose one of 25 coordinated font sets, and it will be consistently applied to your publication. Publisher now makes it easy to prepare Word documents with great-looking professional designs by using the Word Import Wizard. Fifteen new Design Sets aimed at producing streamlined, professional-quality business publications have been added to Publisher. Many Publisher features—wizards, designs, and color schemes—have been redesigned for easy access in the task pane. Publisher includes a style inspector that describes the properties of the current style, allowing you to make better use of styles. Now you can save and open documents in HTML file format. The new mail-merge feature in Publisher is more like mail merge in Word, making it easier to use.
  • Drawing tool Publisher 2002 uses the same drawing tools, including AutoShapes, used by other Office applications. You can now move objects inline with text in text frames. Once moved inline, graphics flow with text in frames. Publisher now supports cyan-magenta-yellow-black (CMYK) TIFFs internally. You're no longer required to link to externally stored TIFFs. Publisher can separate vector and bitmap red-green-blue (RGB) images. Publisher supports print previews of the current publication, using the characteristics of the current printer to render the preview. If you're using either process or spot color, print preview can display both a composite preview and previews of individual ink plates. Printing is easier now that the Print Setup and Page Setup dialog boxes have been merged into a single dialog box.
  • International support Publisher 2002 now includes support for complex scripts and bidirectional languages, such as Arabic and Hebrew. Publisher uses Office "word-breaking" technology to detect word breaks in Japanese and Chinese text for easy selection and editing of your text. Publisher now supports the Office Language Settings tool to let users enable language-specific editing features and the language used in online Help.